<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL  & ~(E_STRICT|E_NOTICE| E_WARNING | E_PARSE |E_DEPRECATED) );

chdir(dirname(__FILE__));
require "../init.php";

$vtod = init_vtod();
$vtod_config_url = $vtod_config["url"];

$listContacts = getAllContacts($vtod);
if(count($listContacts) >0) {
    foreach($listContacts as $k => $val) {
        $contactId = $val['id'];
        $lastname = $val['lastname'];
        $lastname_arr = explode(" ",$lastname);
        $fistname_val = "";
        $lastname_val = "";
        if(count($lastname_arr) == 2) {
            $fistname_val = $lastname_arr[0];
            $lastname_val = $lastname_arr[1];
            updateContact($vtod,$vtod_config_url,$contactId,$fistname_val,$lastname_val);
        } elseif(count($lastname_arr) == 3) {
            $fistname_val = $lastname_arr[0]." ".$lastname_arr[1];
            $lastname_val = $lastname_arr[2];
            updateContact($vtod,$vtod_config_url,$contactId,$fistname_val,$lastname_val);
        }

    }
}
echo "Done.";
exit;

function updateContact($vtod,$vtod_config_url,$contactId,$fistname_val,$lastname_val) {
    $update_contact = $vtod->retrieve($contactId);
    if ($update_contact) {
        $update_contact['firstname'] = $fistname_val;
        $update_contact['lastname'] = $lastname_val;
        $objectJson = json_encode($update_contact);
        $params = array(
            "sessionName" => $vtod->sessionId,
            "operation" => 'update',
            "element" => $objectJson
        );
        try {
            $res = curlPost($vtod_config_url . "webservice.php", $params);
            $response = json_decode($res, 1);
            if(!$response['error']) {
                pushlog("Update Contact ".$contactId." with First Name: ".$fistname_val." and Last Name: ".$lastname_val);
            } else {
                pushlog($response['error']['message']);
            }
        } catch (Exception $e) {
            pushlog($e->getMessage());
        }
    }
}

function getAllContacts($vtod) {
    $query = "SELECT COUNT(*) FROM Contacts WHERE firstname=' ' AND source='IMPORT';";
    $contactCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $contactCount = intval($rs[0]['count']);
    }

    $arr_contact = [];
    if ($contactCount < 200) {
        $sql = "SELECT id,lastname FROM Contacts WHERE firstname=' ' AND source='IMPORT';";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $contact_val) {
                $arr_contact[] = $contact_val;
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $contactCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT id,lastname FROM Contacts WHERE firstname=' ' AND source='IMPORT' ORDER BY createdtime ASC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $contact_val) {
                $arr_contact[] = $contact_val;
            }
        }

        foreach ($offsetArr as $key => $value) {
            $flag++;
            $offset = $value;

            $sql = "SELECT id,lastname FROM Contacts WHERE firstname=' ' AND source='IMPORT' ORDER BY createdtime ASC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $contact_val) {
                    $arr_contact[] = $contact_val;
                }
            }
        }
    }
    return $arr_contact;
}


function curlPost($url, $data = null, $headers = null) {
    $ch = curl_init($url);
    //curl_setopt($ch, CURLOPT_HEADER, FALSE);
    if($headers)
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, TRUE);
    if (is_array($data)) {
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    }
    $userAgent = 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:40.0) Gecko/20100101 Firefox/40.0';
    curl_setopt($ch, CURLOPT_USERAGENT, $userAgent);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FAILONERROR, TRUE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLINFO_HEADER_OUT, TRUE);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
    curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
    if(curl_errno($ch)){
        echo curl_error($ch);
        return false;
    }
    $response = curl_exec($ch);
    curl_close($ch);
    return $response;
}

function pushlog($var)
{
    $content = date("Y-m-d H:i:s") . "\t";
    if (is_array($var) || is_object($var)) {
        $content .= print_r($var, true);
    } else {
        $content .= $var;
    }
    $content .= "\n";
    file_put_contents(dirname(__FILE__) . "/53530_updateFirstNameContacts_".date('Ymd').".log", $content, FILE_APPEND);
}