
<?php
/**
 * TaskId: 54333
 * User: rprajapati
 * Date: 30/8/22
 */

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: PUT, GET, POST");
header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept");

chdir(dirname(__FILE__));

try {
    require "../VT9_API/init_vt9.php";
} catch (Exception $e) {
}

try {
    require "../init.php";
} catch (Exception $e) {
}
putLogData('Login Successful');
$result = array(
    'success' => false,
    'error' => 'Record not found.',
);

if (!empty($_REQUEST['contactid'])) {
    putLogData('Contact Id found in request -> '.$_REQUEST['contactid']);
    global $mail_config;

    $contactid = $_REQUEST['contactid'];
    $eventid = '18x'.$_REQUEST['eventid'];
    $eventHtml = $_REQUEST['eventHtml'];
    $from = $mail_config['mail_from'];
    $dataUser = $vtod->retrieve($vtod->userId);

    date_default_timezone_set($dataUser['time_zone']);

    try {
	    putLogData('Getting contact information -> ');
        $dataCon = $vtod->retrieve($contactid);
        putLogData($dataCon);
    } catch (Exception $e) {
        putLogData('Error in retrieving contact information'.$e->getMessage());
    }

    $to_email = $dataCon['email'];

    try {
        if($_REQUEST['eventid'] > 0){
	        putLogData('Event Id found in request -> '.$_REQUEST['eventid']);
            try {
                putLogData('Select event record as per event Id -> '.$eventid);
                $sqlGet = "SELECT eventid FROM boru_event_invitees WHERE eventid = ? AND contacts = ?";
                $dataCheck = $dbh->getSingle($sqlGet, array($eventid, $contactid));
            } catch (Exception $e) {
                putLogData('Error selecting event Id'.$e->getMessage());
            }

            if ($dataCheck === false){
		        putLogData('Event record did not found from DB -> '.$eventid);
                try {
                    putLogData('Inserting event record -> '.$eventid);
                    $sql = "INSERT INTO `boru_event_invitees` (`eventid`,`contacts`,`datetime`,`status`) VALUES (?,?,NOW(),?)";
                    $dbh->run($sql, array($eventid, $contactid, 'Date confirmed'));
                } catch (Exception $e) {
                    putLogData('Inserting record to boru_event_invitees'.$e->getMessage());
                }
            }else{
                try {
                    putLogData('Updating event record as date confirmed -> '.$eventid);
                    $sql = "UPDATE `boru_event_invitees` SET `datetime`= NOW(), status = ? WHERE eventid = ? AND contacts = ? ";
                    $dbh->run($sql, array('Date confirmed', $eventid, $contactid));
                } catch (Exception $e) {
                    putLogData('Updating record to boru_event_invitees '.$e->getMessage());
                }
            }
        }else{
            putLogData('Event Id not present in request');
            try {
                putLogData('Updating contact confirmation status');
                $data = $vtod->revise(array(
                    'id' => $contactid,
                    'cf_contacts_confirmationstatus' => "Date Accepted"
                ));
                putLogData($data);
            } catch (Exception $e) {
                putLogData('Updating contact confirmation status'.$e->getMessage());
            }

            if (!empty($data['account_id'])) {
                putLogData('Account found related to contact');
                try {
                    putLogData('Updating account confirmation status');
                    $data2 = $vtod->revise(array(
                        'id' => $data['account_id'],
                        'cf_accounts_eventstatus' => "Dates Accepted"
                    ));
                    putLogData($data2);
                } catch(Exception $e) {
                    putLogData('Updating account confirmation status'.$e->getMessage());
                }
            }
        }

        if (!empty($to_email) && !empty($eventHtml)) {

            try {
                putLogData('Sending date confirmation mail');
                $query = "SELECT * FROM EmailTemplates where templatename = 'Dates Confirmation Email' LIMIT 1;";
                $data = $vtod->query($query);
            } catch (Exception $e) {
                putLogData('selecting email templates'.$e->getMessage());
            }

            $subject = $data[0]['subject'];
            $body = $data[0]['body'];

            foreach ($dataCon as $fieldName => $fieldVal) {
                $needle = '$contacts-' . $fieldName . '$';

                $subject = str_replace($needle, $fieldVal, $subject);
                $body = str_replace($needle, $fieldVal, $body);
            }

            $body = str_replace("{{contacteventshtml}}", $eventHtml, $body);

            $arrEmail['date_start'] = date('Y-m-d H:i:s');
            $arrEmail['time_start'] = date('H:i:s');
            $arrEmail['subject'] = urlencode(strip_tags_content($subject));
            $arrEmail['description'] = urlencode(strip_tags_content($body));
            $arrEmail['from_email'] = $from;
            $arrEmail['saved_toid'] = $to_email;
            $arrEmail['assigned_user_id'] = $vtod->userId;
            $arrEmail['parent_id'] = $contactid;

            try {
                putLogData('Creating email record');
                $resultEmail = $vtod->create("Emails", $arrEmail);
                putLogData('Email record created -> '.$resultEmail['id'].$to_email.$subject);
                if (!empty($resultEmail['id'])) {
                    $data = sendMail($from, '', [$to_email], $subject, $body);
                }
            } catch (Exception $e) {
                putLogData('Creating email record'.$e->getMessage());
            }
        }
        $result = array(
            'success' => true
        );
    } catch (Exception $e) {
        $result = array(
            'success' => false,
            'error' => 'Error while saving record.',
            'errorDesc' => $e->getMessage(),
        );
    }
} else {
putLogData('Contact Id not found in request');
}

function strip_tags_content($string)
{
    // ----- remove control characters -----
    $string = str_replace('&', 'and', $string);
    $string = str_replace(' ', '-', $string);
    $string = str_replace('-', ' ', $string);
    $string = str_replace("\r", '', $string);
    $string = str_replace("\n", ' ', $string);
    $string = str_replace("\t", ' ', $string);
    $string = htmlspecialchars($string);
    // ----- remove multiple spaces -----
    $string = trim(preg_replace('/ {2,}/', ' ', $string));
    return $string;

}


echo json_encode($result);
exit;