<?php
/**
 * Created by Boru
 * User: IN-Team
 * Date: 06/13/2022
 * Time: 3:52 PM
 */

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
ini_set('display_errors','on'); version_compare(PHP_VERSION, '5.5.0') <= 0 ? error_reporting(E_WARNING & ~E_NOTICE & ~E_DEPRECATED) : error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED & ~E_STRICT);   // DEBUGGING
ini_set('display_errors','on'); error_reporting(E_ALL); // STRICT DEVELOPMENT
chdir(dirname(__FILE__).'/..');
require "init.php";
include_once 'custommods/AgileCRMAPI_Util.php';

$vtod_config_url = $vtod_config["url"];
date_default_timezone_set("UTC");

pushlog("====== start import Events ======");


$listEventsjson = file_get_contents('Events/listEvents.json');
$listContactjson = file_get_contents('Events/listContact.json');
$listDealsjson = file_get_contents('Events/listDeals.json');
$listAccountjson = file_get_contents('Events/listAccount.json');
$listUsersjson = file_get_contents('Events/listUsers.json');

$listEvents = json_decode($listEventsjson,true);
$listContact = json_decode($listContactjson,true);
$listDeals = json_decode($listDealsjson,true);
$listUsers = json_decode($listUsersjson,true);
$listAccount = json_decode($listAccountjson,true);

try {
    $vtod = init_vtod();
    if(count($listEvents) == 0) $listEvents = getAllEvents($vtod);
    if(count($listContact) == 0) $listContact = getAllContact($vtod);
    if(count($listDeals) == 0) $listDeals = getAllDeals($vtod);
    if(count($listUsers) == 0) $listUsers = getAllUser($vtod);
    if(count($listAccount) == 0) $listAccount = getAllOrg($vtod);
}catch(Exception $e) {
    pushlog("--- Error to get records --- = ".$e->getMessage());
    exit;
}
file_put_contents('Events/listEvents.json', json_encode($listEvents));
file_put_contents('Events/listContact.json', json_encode($listContact));
file_put_contents('Events/listDeals.json', json_encode($listDeals));
file_put_contents('Events/listAccount.json', json_encode($listAccount));
file_put_contents('Events/listUsers.json', json_encode($listUsers));


pushlog("====== Count listDeals ======".count($listDeals));
pushlog("====== Count listContact ======".count($listContact));
pushlog("====== Count listAccount ======".count($listAccount));
pushlog("====== Count listUsers ======".count($listUsers));
pushlog("====== Count listEvents ======".count($listEvents));

// create class object to Agile CRMA PI Call
$agilecrmapiobj = new AgileCRMAPI();

echo "<br> startdate = ".$startdate = date('Y-m-d',strtotime("-10 days"));
echo "<br> enddate = ".$enddate = date('2022-12-31');

$data['startdate'] = strtotime($startdate);
$data['enddate'] = strtotime($enddate);

$listofallevents = $agilecrmapiobj->getallEvents($data);
$listofallevents = json_decode($listofallevents,true);

pushlog("--- Total Count ---".count($listofallevents));

$ownerInfoNotExist = array();
$createdEventsArr = array();
$updatedEventsArr = array();
foreach ($listofallevents as $key => $rowdata) {
    $relatedAccountArr = array();
    $relatedDealArr = array();

    if($rowdata['owner'] == ''){
        pushlog("--- start owner Info Not exists ---");
        pushlog($rowdata);
        pushlog("--- end owner Info Not exists --- ");
        $ownerInfoNotExist[] = $rowdata['id'];
        continue;
    }

    $rowdata['start'] = substr($rowdata['start'],0,10);
    $rowdata['end'] = substr($rowdata['end'],0,10);

    $eventArr = [];
    $eventArr['cf_events_agilecrmid'] = $rowdata['id'];
    $eventArr['subject'] = $rowdata['title'];
    $eventArr['date_start'] = date('Y-m-d',$rowdata['start']);
    $eventArr['time_start'] = date('H:i:s',$rowdata['start']);
    $eventArr['due_date'] = date('Y-m-d',$rowdata['end']);
    $eventArr['time_end'] = date('H:i:s',$rowdata['end']);
    if(date('Y-m-d',$rowdata['end']) < date('Y-m-d')){
        $eventArr['eventstatus'] = "Held";
    }else{
        $eventArr['eventstatus'] = "Planned";
    }
    
    $eventArr['activitytype'] = "Call";
    $eventArr['allday'] = 0;
    $eventArr['meeting_notes'] = $rowdata['description'];

    // find contact and attached with Event record
    if(count($rowdata['contacts']) > 0){

        foreach ($rowdata['contacts'] as $k => $contactsDetails) {
            if($contactsDetails['type'] == 'PERSON'){
                $contactNameArr = '';
                foreach ($contactsDetails['properties'] as $j => $contactsDetail) {
                    $contactNameArr[$contactsDetail['name']] = $contactsDetail['value'];
                }
                $contactName = $contactNameArr['first_name'] . ' ' .$contactNameArr['last_name'];
                $contactName1 = $contactNameArr['last_name'] . ' ' .$contactNameArr['first_name'];
                pushlog("Contact contactName =".$contactName);
                pushlog("Contact contactName1 =".$contactName1);
                if(!empty($contactName) && isset($listContact[$contactName]) || isset($listContact[$contactName1])){
                    $eventArr['contact_id'] = $listContact[$contactName];
                    $contactArr[] = $listContact[$contactName];
                    if(isset($listDeals[$listContact[$contactName]])){
                        pushlog("Match Deal for Contact =". $listContact[$contactName] ." Deal ID = ".$listDeals[$listContact[$contactName]]);
                        $relatedDealArr[] = $listDeals[$listContact[$contactName]];
                    }elseif(isset($listDeals[$listContact[$contactName1]])){
                        pushlog("Match Deal for Contact =". $listContact[$contactName1] ." Deal ID = ".$listDeals[$listContact[$contactName1]]);
                        $relatedDealArr[] = $listDeals[$listContact[$contactName1]];
                    }else{
                        pushlog("Not Found Deal for this Conatct =". $listContact[$contactName]);
                        pushlog("Not Found Deal for this Conatct1 =". $listContact[$contactName1]);
                    }
                }

            }elseif($contactsDetails['type'] == 'COMPANY'){
                $companyname = '';
                foreach ($contactsDetails['properties'] as $j => $orgDetail) {
                    $companyname = $orgDetail['value'];
                }
                pushlog("Company Name =".$companyname);
                if(!empty($companyname) && isset($listAccount[$companyname])){
                    pushlog("Match Company Name =".$companyname ." ID = ".$listAccount[$companyname]);
                    $eventArr['account_id'] = $listAccount[$companyname];
                    $relatedAccountArr[] = $listAccount[$companyname];
                }else{
                    pushlog("Not Found Company Name =".$companyname);
                }
            }
        }
    }
    if(count($rowdata['owner']) > 0){
        $ownerName = $rowdata['owner']['name'];
        pushlog("OwnerName =".$ownerName);
         if(isset($listUsers[$ownerName])){
            pushlog("Match OwnerName =".$ownerName . " ID = ".$listUsers[$ownerName]);
            $eventArr['assigned_user_id'] = $listUsers[$ownerName];
         }else{
            pushlog("Not Match OwnerName =".$ownerName);
            $ownerName = 'Boru Tester';
            $eventArr['assigned_user_id'] = $listUsers[$ownerName];
         }

         try {
            pushlog("--- start Create/Update Event ---".$eventArr['cf_events_agilecrmid']);
            pushlog($eventArr);
            if(!empty($listEvents[$eventArr['cf_events_agilecrmid']])){
                pushlog("--- Allready exists Updating Event --- CRM ID = ".$listEvents[$eventArr['cf_events_agilecrmid']]);
                $eventArr['id'] = $listEvents[$eventArr['cf_events_agilecrmid']];
                $eventResult = $vtod->update($eventArr);
                pushlog("--- Updated Event ---".$eventResult['id']);
                if($eventResult['id'] > 0){
                    $updatedEventsArr[] = $eventResult['id'];
                }
            }else{
                $eventResult = $vtod->create('Events',$eventArr);
                pushlog("--- created Event ---".$eventResult['id']);
                if($eventResult['id'] > 0){
                    $createdEventsArr[] = $eventResult['id'];
                }
            }
            if($eventResult['id'] > 0 && count($relatedDealArr) > 0){
                foreach ($relatedDealArr as $key => $potentialId) {
                    linkEventToRecord($vtod,$vtod_config_url,$eventResult['id'],$potentialId,'Potentials');
                }
            }
            if($eventResult['id'] > 0 && count($relatedAccountArr) > 0){
                foreach ($relatedAccountArr as $key => $accountId) {
                    pushlog("Link accountId = ".$accountId . " Event id = ".$eventResult['id']);
                    linkEventToRecord($vtod,$vtod_config_url,$eventResult['id'],$accountId,'Organizations');
                }
            }
        }catch(Exception $e) {
            pushlog("--- Error create Event --- = ".$e->getMessage());
        }
    }
}

pushlog('------ owner Info Not Exist ------');
pushlog($ownerInfoNotExist);

pushlog('------ Total updated Events ------');
pushlog($updatedEventsArr);

pushlog('------ Total created Events ------');
pushlog($createdEventsArr);

echo "Import Successfully";

function linkEventToRecord(dhvt $vtod,$vtod_config_url,$eventId,$potentialId,$modulename) {
    $vtod->addRelated($eventId,$potentialId, $modulename);
}

function getAllUser($vtod) {
    $query = "SELECT COUNT(*) FROM Users;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }

    $arr_users = [];
    if ($conCount < 200) {
        $sql = "SELECT first_name, last_name FROM Users;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $userdata) {
                $fullname = $userdata['first_name'] ." ".$userdata['last_name'];
                $arr_users[$fullname] = $userdata['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT first_name, last_name FROM Users ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $userdata) {
                $fullname = $userdata['first_name'] ." ".$userdata['last_name'];
                $arr_users[$fullname] = $userdata['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            $flag++;
            $offset = $value;

            $sql = "SELECT first_name, last_name FROM Users ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $userdata) {
                    $fullname = $userdata['first_name'] ." ".$userdata['last_name'];
                    $arr_users[$fullname] = $userdata['id'];
                }
            }
        }
    }
    return $arr_users;
}
function getAllOrg($vtod) {
    pushlog("--- start getAllOrg ---");
    $query = "SELECT COUNT(*) FROM Accounts;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }
    pushlog("--- Total AllOrg ---".$conCount);
    $arr_account = [];
    if ($conCount < 200) {
        $sql = "SELECT accountname FROM Accounts;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $accountdata) {
                $arr_account[$accountdata['accountname']] = $accountdata['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT accountname FROM Accounts ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $accountdata) {
                $arr_account[$accountdata['accountname']] = $accountdata['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("--- IN getAllOrg ---offset - ---".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT accountname FROM Accounts ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $accountdata) {
                    $arr_account[$accountdata['accountname']] = $accountdata['id'];
                }
            }
        }
    }
    pushlog("--- start getAllOrg ---");
    return $arr_account;
}

function getAllContact($vtod) {
    pushlog("--- start getAllContact ---");
    $query = "SELECT COUNT(*) FROM Contacts;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }
    pushlog("--- Total AllContact ---".$conCount);
    $arr_contact = [];
    if ($conCount < 200) {
        $sql = "SELECT firstname, lastname FROM Contacts;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $contactdata) {
                $fullname = $contactdata['firstname'] ." ".$contactdata['lastname'];
                $arr_contact[$fullname] = $contactdata['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT firstname, lastname FROM Contacts ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $contactdata) {
                $fullname = $contactdata['firstname'] ." ".$contactdata['lastname'];
                $arr_contact[$fullname] = $contactdata['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("--- IN getAllContact ---offset - ".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT firstname, lastname FROM Contacts ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $contactdata) {
                    $fullname = $contactdata['firstname'] ." ".$contactdata['lastname'];
                    $arr_contact[$fullname] = $contactdata['id'];
                }
            }
        }
    }
    pushlog("--- end getAllContact ---");
    return $arr_contact;
}
function getAllDeals($vtod) {
    pushlog("--- start getAllDeals ---");
    $query = "SELECT COUNT(*) FROM Potentials;";
    $potentialCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $potentialCount = intval($rs[0]['count']);
    }
    pushlog("--- Total AllDeals ---".$potentialCount);
    $arr_poten = [];
    if ($potentialCount < 200) {
        $sql = "SELECT contact_id FROM Potentials;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $poten_val) {
                if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['contact_id']] = $poten_val['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $potentialCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT contact_id FROM Potentials ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $poten_val) {
                if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['contact_id']] = $poten_val['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("--- IN getAllDeals ---offset - ".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT contact_id FROM Potentials ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $poten_val) {
                    if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['contact_id']] = $poten_val['id'];
                }
            }
        }
    }
    pushlog("--- End getAllDeals ---");
    return $arr_poten;
}
function getAllTasks($vtod) {
    pushlog("--- start getAllTasks ---");
    $query = "SELECT COUNT(*) FROM Calendar WHERE cf_calendar_agilecrmid > 0;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }
    pushlog("--- Total AllTasks ---".$conCount);

    $arr_tasks = [];
    if ($conCount < 200) {
        $sql = "SELECT * FROM Calendar WHERE cf_calendar_agilecrmid > 0;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $tasksData) {
               $arr_tasks[$tasksData['cf_calendar_agilecrmid']] = $tasksData['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT cf_calendar_agilecrmid FROM Calendar WHERE cf_calendar_agilecrmid > 0 ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $tasksData) {
                $arr_tasks[$tasksData['cf_calendar_agilecrmid']] = $tasksData['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("--- IN getAllTasks ---offset - ".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT cf_calendar_agilecrmid FROM Calendar WHERE cf_calendar_agilecrmid > 0 ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $tasksData) {
                    $arr_tasks[$tasksData['cf_calendar_agilecrmid']] = $tasksData['id'];
                }
            }
        }
    }
    pushlog("--- END getAllTasks ---");
    return $arr_tasks;
}
function getAllEvents($vtod) {
    pushlog("--- start getAllEvents ---");
    $query = "SELECT COUNT(*) FROM Events WHERE cf_events_agilecrmid > 0;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }
    pushlog("--- Total AllEvents ---".$conCount);
    $arr_events = [];
    if ($conCount < 200) {
        $sql = "SELECT * FROM Events WHERE cf_events_agilecrmid > 0;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $eventdata) {
                $arr_events[$eventdata['cf_events_agilecrmid']] = $eventdata['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT cf_events_agilecrmid FROM Events WHERE cf_events_agilecrmid > 0 ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $eventdata) {
                $arr_events[$eventdata['cf_events_agilecrmid']] = $eventdata['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("--- IN getAllEvents ---offset - ".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT cf_events_agilecrmid FROM Events WHERE cf_events_agilecrmid > 0 ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $eventdata) {
                    $arr_events[$eventdata['cf_events_agilecrmid']] = $eventdata['id'];
                }
            }
        }
    }
    pushlog("--- END getAllEvents ---");
    return $arr_events;
}

function pushlog($var) {
    $content = date("Y-m-d H:i:s") . "\t";
    if (is_array($var) || is_object($var)) {
        $content .= print_r($var, true);
    } else {
        $content .= $var;
    }
    echo $content .= "\n <br>";
    file_put_contents("logs/53234_importEvents_".date('Ymd').".log", $content, FILE_APPEND);
}
?>