<?php
/**
 * Created by Boru
 * User: IN-Team
 * Date: 06/13/2022
 * Time: 3:52 PM
 */

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
ini_set('display_errors','on'); version_compare(PHP_VERSION, '5.5.0') <= 0 ? error_reporting(E_WARNING & ~E_NOTICE & ~E_DEPRECATED) : error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED & ~E_STRICT);   // DEBUGGING
ini_set('display_errors','on'); error_reporting(E_ALL); // STRICT DEVELOPMENT
chdir(dirname(__FILE__).'/..');

require "init.php";
include_once 'custommods/AgileCRMAPI_Util.php';

date_default_timezone_set("UTC");


$vtod_config_url = $vtod_config["url"];

pushlog("====== start import Task ======");
$listUsersjson = file_get_contents('/var/www/html/Vtiger-7/resilience/Events/listUsers.json');
$listUsers = json_decode($listUsersjson,true);
pushlog("====== Count listUsers ======".count($listUsers));

$listTasksjson = file_get_contents('/var/www/html/Vtiger-7/resilience/Events/listTasks.json');
$listContactjson = file_get_contents('/var/www/html/Vtiger-7/resilience/Events/listContact.json');
$listDealsjson = file_get_contents('/var/www/html/Vtiger-7/resilience/Events/listDeals.json');
$listAccountjson = file_get_contents('/var/www/html/Vtiger-7/resilience/Events/listAccount.json');
$listUsersjson = file_get_contents('/var/www/html/Vtiger-7/resilience/Events/listUsers.json');

$listTasks = json_decode($listTasksjson,true);
$listContact = json_decode($listContactjson,true);
$listDeals = json_decode($listDealsjson,true);
$listUsers = json_decode($listUsersjson,true);
$listAccount = json_decode($listAccountjson,true);

try {
    $vtod = init_vtod();
    if(count($listTasks) == 0) $listTasks = getAllTasks($vtod);
    if(count($listContact) == 0) $listContact = getAllContact($vtod);
    if(count($listDeals) == 0) $listDeals = getAllDeals($vtod);
    if(count($listUsers) == 0) $listUsers = getAllUser($vtod);
    if(count($listAccount) == 0) $listAccount = getAllOrg($vtod);
}catch(Exception $e) {
    pushlog("--- Error to get records --- = ".$e->getMessage());
    exit;
}
file_put_contents('/var/www/html/Vtiger-7/resilience/Events/listTasks.json', json_encode($listTasks));
file_put_contents('/var/www/html/Vtiger-7/resilience/Events/listContact.json', json_encode($listContact));
file_put_contents('/var/www/html/Vtiger-7/resilience/Events/listDeals.json', json_encode($listDeals));
file_put_contents('/var/www/html/Vtiger-7/resilience/Events/listAccount.json', json_encode($listAccount));
file_put_contents('/var/www/html/Vtiger-7/resilience/Events/listUsers.json', json_encode($listUsers));


pushlog("====== Count listDeals ======".count($listDeals));
pushlog("====== Count listContact ======".count($listContact));
pushlog("====== Count listAccount ======".count($listAccount));
pushlog("====== Count listUsers ======".count($listUsers));
pushlog("====== Count listTasks ======".count($listTasks));


// create class object to Agile CRMA PI Call
$agilecrmapiobj = new AgileCRMAPI();


$page = 1911;

$listofalltask = $agilecrmapiobj->getallTasks($page);
$listofalltask = json_decode($listofalltask,true);

pushlog("--- Total Count ---".count($listofalltask));
if(count($listofalltask) == 0){
    pushlog("--- No record found from Agile CRM ---");
    exit;
}
$ownerInfoNotExist = array();
$createdTasksArr = array();
$updatedTasksArr = array();
foreach ($listofalltask as $key => $rowdata) {
    if($rowdata['taskOwner'] == ''){
        pushlog("--- start owner Info Not exists ---");
        pushlog($rowdata);
        pushlog("--- end owner Info Not exists --- ");
        $ownerInfoNotExist[] = $rowdata['id'];
        continue;
    }

    $rowdata['due'] = substr($rowdata['due'],0,10);
    $taskArr = [];
    $taskArr['cf_calendar_agilecrmid'] = $rowdata['id'];
    $taskArr['subject'] = $rowdata['subject'];
    $taskArr['date_start'] = date('Y-m-d',$rowdata['due']);
    $taskArr['time_start'] = date('H:i:s',$rowdata['due']);
    $taskArr['due_date'] = date('Y-m-d',$rowdata['due']);
    $taskArr['time_end'] = date('H:i:s',$rowdata['due']);
    $taskArr['taskstatus'] = $rowdata['status'];
    $taskArr['tasktype'] = str_replace('_', ' ', ucfirst($rowdata['type']));
    $taskArr['taskpriority'] = ucfirst($rowdata['priority_type']);
    $taskArr['description'] = $rowdata['taskDescription'];


    // find contact and attached with Task record
    if(count($rowdata['contacts']) > 0){
        $contactArr = array();
        foreach ($rowdata['contacts'] as $k => $contactsDetails) {
            if($contactsDetails['type'] == 'PERSON'){
                $contactNameArr = '';
                foreach ($contactsDetails['properties'] as $j => $contactsDetail) {
                    $contactNameArr[$contactsDetail['name']] = $contactsDetail['value'];
                }
                $contactName = $contactNameArr['first_name'] . ' ' .$contactNameArr['last_name'];
                $contactName1 = $contactNameArr['last_name'] . ' ' .$contactNameArr['first_name'];
                if(!empty($contactName) && isset($listContact[$contactName]) || isset($listContact[$contactName1])){
                    $taskArr['contact_id'] = $listContact[$contactName];
                    $contactArr[] = $listContact[$contactName];
                    if(isset($listDeals[$listContact[$contactName]])){
                        pushlog("Match Deal for Contact =". $listContact[$contactName] ." Deal ID = ".$listDeals[$listContact[$contactName]]);
                        $relatedDealArr[] = $listDeals[$listContact[$contactName]];
                    }elseif(isset($listDeals[$listContact[$contactName1]])){
                        pushlog("Match Deal for Contact =". $listContact[$contactName1] ." Deal ID = ".$listDeals[$listContact[$contactName1]]);
                        $relatedDealArr[] = $listDeals[$listContact[$contactName1]];
                    }else{
                        pushlog("Not Found Deal for this Conatct =". $listContact[$contactName]);
                        pushlog("Not Found Deal for this Conatct1 =". $listContact[$contactName1]);
                    }
                }

            }elseif($contactsDetails['type'] == 'COMPANY'){
                $companyname = '';
                foreach ($contactsDetails['properties'] as $j => $orgDetail) {
                    $companyname = $orgDetail['value'];
                }
                if(!empty($companyname) && isset($listAccount[$companyname])){
                    $taskArr['account_id'] = $listAccount[$companyname];
                }
            }
        }
    }
    if(count($rowdata['taskOwner']) > 0){
        $ownerName = $rowdata['taskOwner']['name'];
         if(isset($listUsers[$ownerName])){
            $taskArr['assigned_user_id'] = $listUsers[$ownerName];
         }else{
            $ownerName = 'Boru Tester';
            $taskArr['assigned_user_id'] = $listUsers[$ownerName];
         }

         try {
            pushlog("--- start Create/Update Task ---".$taskArr['cf_calendar_agilecrmid']);
            pushlog($taskArr);
            if(!empty($listTasks[$taskArr['cf_calendar_agilecrmid']])){
                pushlog("--- Allready exists Updating Task --- CRM ID = ".$listTasks[$taskArr['cf_calendar_agilecrmid']]);
                $taskArr['id'] = $listTasks[$taskArr['cf_calendar_agilecrmid']];
                $taskResult = $vtod->update($taskArr);
                pushlog("--- Updated Task ---".$taskResult['id']);
                if($taskResult['id'] > 0){
                    $updatedTasksArr[] = $taskResult['id'];
                }
            }else{
                $taskResult = $vtod->create('Calendar',$taskArr);
                pushlog("--- created Task ---".$taskResult['id']);
                if($taskResult['id'] > 0){
                    $createdTasksArr[] = $taskResult['id'];
                }
            }
            if($taskResult['id'] > 0 && count($contactArr) > 0){
                foreach ($contactArr as $key => $contactid) {
                    linkEventToRecord($vtod,$vtod_config_url,$taskResult['id'],$contactid,'Contacts');
                }
            }
            /*if($taskResult['id'] > 0 && count($relatedDealArr) > 0){
                foreach ($relatedDealArr as $key => $potentialId) {
                    linkEventToRecord($vtod,$vtod_config_url,$taskResult['id'],$potentialId,'Potentials');
                }
            }*/
        }catch(Exception $e) {
            pushlog("--- Error create Task --- = ".$e->getMessage());
        }
    }
}

pushlog('------ owner Info Not Exist ------');
pushlog($ownerInfoNotExist);

pushlog('------ Total updated Tasks ------');
pushlog($updatedTasksArr);

pushlog('------ Total created Tasks ------');
pushlog($createdTasksArr);

echo "Import Successfully";

function linkEventToRecord(dhvt $vtod,$vtod_config_url,$eventId,$potentialId,$modulename) {
    $vtod->addRelated($eventId,$potentialId, $modulename);
}

function getAllUser($vtod) {
    $query = "SELECT COUNT(*) FROM Users;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }

    $arr_users = [];
    if ($conCount < 200) {
        $sql = "SELECT first_name, last_name FROM Users;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $userdata) {
                $fullname = $userdata['first_name'] ." ".$userdata['last_name'];
                $arr_users[$fullname] = $userdata['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT first_name, last_name FROM Users ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $userdata) {
                $fullname = $userdata['first_name'] ." ".$userdata['last_name'];
                $arr_users[$fullname] = $userdata['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            $flag++;
            $offset = $value;

            $sql = "SELECT first_name, last_name FROM Users ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $userdata) {
                    $fullname = $userdata['first_name'] ." ".$userdata['last_name'];
                    $arr_users[$fullname] = $userdata['id'];
                }
            }
        }
    }
    return $arr_users;
}
function getAllOrg($vtod) {
    pushlog("--- start getAllOrg ---");
    $query = "SELECT COUNT(*) FROM Accounts;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }

    $arr_account = [];
    if ($conCount < 200) {
        $sql = "SELECT accountname FROM Accounts;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $accountdata) {
                $arr_account[$accountdata['accountname']] = $accountdata['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT accountname FROM Accounts ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $accountdata) {
                $arr_account[$accountdata['accountname']] = $accountdata['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("--- IN getAllOrg ---offset - ---".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT accountname FROM Accounts ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $accountdata) {
                    $arr_account[$accountdata['accountname']] = $accountdata['id'];
                }
            }
        }
    }
    pushlog("--- start getAllOrg ---");
    return $arr_account;
}

function getAllContact($vtod) {
    pushlog("--- start getAllContact ---");
    $query = "SELECT COUNT(*) FROM Contacts;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }

    $arr_contact = [];
    if ($conCount < 200) {
        $sql = "SELECT firstname, lastname FROM Contacts;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $contactdata) {
                $fullname = $contactdata['firstname'] ." ".$contactdata['lastname'];
                $arr_contact[$fullname] = $contactdata['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT firstname, lastname FROM Contacts ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $contactdata) {
                $fullname = $contactdata['firstname'] ." ".$contactdata['lastname'];
                $arr_contact[$fullname] = $contactdata['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("--- IN getAllContact ---offset - ".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT firstname, lastname FROM Contacts ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $contactdata) {
                    $fullname = $contactdata['firstname'] ." ".$contactdata['lastname'];
                    $arr_contact[$fullname] = $contactdata['id'];
                }
            }
        }
    }
    pushlog("--- end getAllContact ---");
    return $arr_contact;
}
function getAllDeals($vtod) {
    $query = "SELECT COUNT(*) FROM Potentials;";
    $potentialCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $potentialCount = intval($rs[0]['count']);
    }

    $arr_poten = [];
    if ($potentialCount < 200) {
        $sql = "SELECT contact_id FROM Potentials;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $poten_val) {
                if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['contact_id']] = $poten_val['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $potentialCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT contact_id FROM Potentials ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $poten_val) {
                if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['contact_id']] = $poten_val['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            $flag++;
            $offset = $value;

            $sql = "SELECT contact_id FROM Potentials ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $poten_val) {
                    if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['contact_id']] = $poten_val['id'];
                }
            }
        }
    }
    return $arr_poten;
}
function getAllTasks($vtod) {
    pushlog("--- start getAllTasks ---");
    $query = "SELECT COUNT(*) FROM Calendar WHERE cf_calendar_agilecrmid > 0;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }
    pushlog("--- Total AllTasks ---".$conCount);

    $arr_tasks = [];
    if ($conCount < 200) {
        $sql = "SELECT * FROM Calendar WHERE cf_calendar_agilecrmid > 0;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $tasksData) {
               $arr_tasks[$tasksData['cf_calendar_agilecrmid']] = $tasksData['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT cf_calendar_agilecrmid FROM Calendar WHERE cf_calendar_agilecrmid > 0 ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $tasksData) {
                $arr_tasks[$tasksData['cf_calendar_agilecrmid']] = $tasksData['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("--- IN getAllTasks ---offset - ".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT cf_calendar_agilecrmid FROM Calendar WHERE cf_calendar_agilecrmid > 0 ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $tasksData) {
                    $arr_tasks[$tasksData['cf_calendar_agilecrmid']] = $tasksData['id'];
                }
            }
        }
    }
    pushlog("--- END getAllTasks ---");
    return $arr_tasks;
}

function pushlog($var) {
    $content = date("Y-m-d H:i:s") . "\t";
    if (is_array($var) || is_object($var)) {
        $content .= print_r($var, true);
    } else {
        $content .= $var;
    }
    echo $content .= "\n <br>";
    file_put_contents("logs/53234_importTask_".date('Ymd').".log", $content, FILE_APPEND);
}
?>