<?php
/**
 * Created by Boru
 * User: IN-Team
 * Date: 06/13/2022
 * Time: 3:52 PM
 */

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);

chdir(dirname(__FILE__));
require "../init.php";

$vtod_config_url = $vtod_config["url"];
$importcsvfile = "Events/import-file/AgileCRM.csv";

pushlog("====== start import event ======");

$listEventsjson = file_get_contents('/var/www/html/Vtiger-7/resilience/Events/listEvents.json');
$listAccountjson = file_get_contents('/var/www/html/Vtiger-7/resilience/Events/listAccount.json');
$listUsersjson = file_get_contents('/var/www/html/Vtiger-7/resilience/Events/listUsers.json');

$listEvents = json_decode($listEventsjson,true);
$listUsers = json_decode($listUsersjson,true);
$listAccount = json_decode($listAccountjson,true);

try {
    $vtod = init_vtod();
    if(count($listEvents) == 0) $listEvents = getAllEvents($vtod);
    if(count($listUsers) == 0) $listUsers = getAllUser($vtod);
    if(count($listAccount) == 0) $listAccount = getAllOrg($vtod);
}catch(Exception $e) {
    pushlog("--- Error to get records --- = ".$e->getMessage());
    exit;
}
file_put_contents('/var/www/html/Vtiger-7/resilience/Events/listEvents.json', json_encode($listEvents));
file_put_contents('/var/www/html/Vtiger-7/resilience/Events/listAccount.json', json_encode($listAccount));
file_put_contents('/var/www/html/Vtiger-7/resilience/Events/listUsers.json', json_encode($listUsers));

pushlog("====== Count listAccount ======".count($listAccount));
pushlog("====== Count listEvents ======".count($listEvents));

$csvdatas = formateCSVData($importcsvfile);

pushlog("--- Events record count from CSV= ".count($csvdatas));
$notmatchEvents = array();
$matchEvents = array();
foreach ($csvdatas as $key => $rowdata) {
    if($rowdata['owner'] == ''){
        pushlog("--- start owner Info Not exists ---");
        pushlog($rowdata);
        pushlog("--- end owner Info Not exists --- ");
        continue;
    }
    pushlog("--- start owner Info exists ---");
    pushlog($rowdata);
    
    $startdatetime = $rowdata['start'];
    $startdatearr = explode(" ", $startdatetime);
    $startdate = $startdatearr[0];
    $starttime = $startdatearr[1];

    $enddatetime = $rowdata['end'];
    $enddatearr = explode(" ", $enddatetime);
    $enddate = $enddatearr[0];
    $endtime = $enddatearr[1];

    $eventArr = [];
    $eventArr['cf_events_agilecrmid'] = $rowdata['id'];
    $eventArr['subject'] = $rowdata['title'];
    $eventArr['date_start'] = $startdate;
    $eventArr['time_start'] = $starttime;
    $eventArr['due_date'] = $enddate;
    $eventArr['time_end'] = $endtime;
    $eventArr['eventstatus'] = "Planned";
    $eventArr['activitytype'] = "Call";
    $eventArr['createdtime'] = $rowdata['createdtime'];
    $eventArr['meeting_notes'] = $rowdata['description'];
    $relatedDealArr = array();
    $relatedAccountArr = array();
    if($rowdata['contacts'] != ''){
        $contactArrs = explode("ID = ", $rowdata['contacts']);
        foreach ($contactArrs as $key => $contactArr) {
            $conarray = array();
            $contactDetail = explode("||", $contactArr);
            foreach ($contactDetail as $key => $contactgettype) {
                $contactgettypes = explode("=", $contactgettype);
                if(isset($contactgettypes[0]) && isset($contactgettypes[1])){
                    $conarray[] = array($contactgettypes[0],$contactgettypes[1]);
                }
            }
            if($conarray[0][1] == 'COMPANY'){
                $companyname = trim($conarray[1][1]);
                pushlog("Company Name =".$companyname);
                if(isset($listAccount[$companyname])){
                    pushlog("Match Company Name =".$companyname ." ID = ".$listAccount[$companyname]);
                    $relatedAccountArr[] = $listAccount[$companyname];
                }else{
                    pushlog("Not Found Company Name =".$companyname);
                }
            }
        }
    }
    
    $ownerArr = explode("\n", $rowdata['owner']);
    $ownerNameArr = explode(" = ", $ownerArr[4]);
    $ownerName = trim($ownerNameArr[1]);
    pushlog("OwnerName =".$ownerName);
    if(isset($listUsers[$ownerName])){
        pushlog("Match OwnerName =".$ownerName . " ID = ".$listUsers[$ownerName]);
        $eventArr['assigned_user_id'] = $listUsers[$ownerName];
    }else{
        pushlog("Not Match OwnerName =".$ownerName);
        $ownerName = 'Boru Tester';
        $eventArr['assigned_user_id'] = $listUsers[$ownerName];
        pushlog("Set OwnerName =".$ownerName ." ID = ".$listUsers[$ownerName]);
    }
    pushlog("--- start creat Event ---");
    foreach ($listEvents as $key => $eventdetails) {
        if($eventArr['subject'] == $eventdetails['subject'] && $eventArr['date_start'] == $eventdetails['date_start'] && $eventArr['due_date'] == $eventdetails['due_date'] ){
            try {
            $eventArr['id'] = $eventdetails['id'];
            $reponse = $vtod->update($eventArr);
            $matchEvents[$eventArr['cf_events_agilecrmid']] = $eventArr['cf_events_agilecrmid'];
            pushlog("--- created Event ---".$reponse['id']);
             }catch(Exception $e) {
                pushlog("--- Error create Event --- = ".$e->getMessage());
                $notmatchEvents[$eventArr['cf_events_agilecrmid']] = $eventArr['cf_events_agilecrmid'];
            }
        }else{
            $notmatchEvents[$eventArr['cf_events_agilecrmid']] = $eventArr['cf_events_agilecrmid'];
        }
    }
    if($reponse['id'] > 0 && count($relatedAccountArr) > 0){
        foreach ($relatedAccountArr as $key => $accountId) {
            pushlog("Link accountId = ".$accountId . " Event id = ".$reponse['id']);
            linkEventToRecord($vtod,$vtod_config_url,$reponse['id'],$accountId,'Organizations');
        }
    }
}
pushlog("----- notmatchEvents ------");
pushlog($notmatchEvents);
pushlog("----- matchEvents ------");
pushlog($matchEvents);
pushlog("====== End import event ======");

function getEventByContactId($vtod,$event_id) {
    $query_prod = sprintf("SELECT id FROM Events WHERE contact_id='%s';", $event_id);
    $events = $vtod->query($query_prod);
    if (count($events) >0) {
        return $events;
    }
}

function getAllUser($vtod) {
    pushlog("====== start getAllUser ======");
    $query = "SELECT COUNT(*) FROM Users;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }

    $arr_users = [];
    if ($conCount < 200) {
        $sql = "SELECT first_name, last_name FROM Users;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $userdata) {
                $fullname = $userdata['first_name'] ." ".$userdata['last_name'];
                $arr_users[$fullname] = $userdata['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT first_name, last_name FROM Users ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $userdata) {
                $fullname = $userdata['first_name'] ." ".$userdata['last_name'];
                $arr_users[$fullname] = $userdata['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("====== IN getAllUser ====== offset = ".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT first_name, last_name FROM Users ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $userdata) {
                    $fullname = $userdata['first_name'] ." ".$userdata['last_name'];
                    $arr_users[$fullname] = $userdata['id'];
                }
            }
        }
    }
    pushlog("====== End getAllUser ======");
    return $arr_users;
}
function getAllOrg($vtod) {
    pushlog("--- start getAllOrg ---");
    $query = "SELECT COUNT(*) FROM Accounts;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }

    $arr_account = [];
    if ($conCount < 200) {
        $sql = "SELECT accountname FROM Accounts;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $accountdata) {
                $arr_account[$accountdata['accountname']] = $accountdata['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT accountname FROM Accounts ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $accountdata) {
                $arr_account[$accountdata['accountname']] = $accountdata['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("--- IN getAllOrg --- offset = ".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT accountname FROM Accounts ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $accountdata) {
                    $arr_account[$accountdata['accountname']] = $accountdata['id'];
                }
            }
        }
    }
    pushlog("--- End getAllOrg ---");
    return $arr_account;
}

function getAllEvents($vtod) {
    pushlog("--- start getAllEvents ---");
    $query = "SELECT COUNT(*) FROM Events;";
    $conCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $conCount = intval($rs[0]['count']);
    }

    $arr_contact = [];
    if ($conCount < 200) {
        $sql = "SELECT subject,date_start,time_start,due_date,time_end FROM Events;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $contactdata) {
                $arr_contact[$contactdata['id']] = array('id'=> $contactdata['id'], 'subject'=>$contactdata['subject'],'date_start'=>$contactdata['date_start'],'time_start'=>$contactdata['time_start'],'due_date'=>$contactdata['due_date'],'time_end'=>$contactdata['time_end']);
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $conCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT subject,date_start,time_start,due_date,time_end FROM Events ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $contactdata) {
                $arr_contact[$contactdata['id']] = array('id'=> $contactdata['id'], 'subject'=>$contactdata['subject'],'date_start'=>$contactdata['date_start'],'time_start'=>$contactdata['time_start'],'due_date'=>$contactdata['due_date'],'time_end'=>$contactdata['time_end']);
            }
        }

        foreach ($offsetArr as $key => $value) {
            pushlog("--- IN getAllEvents ---offset - ".$value);
            $flag++;
            $offset = $value;

            $sql = "SELECT subject,date_start,time_start,due_date,time_end FROM Events ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $contactdata) {
                    $arr_contact[$contactdata['id']] = array('id'=> $contactdata['id'], 'subject'=>$contactdata['subject'],'date_start'=>$contactdata['date_start'],'time_start'=>$contactdata['time_start'],'due_date'=>$contactdata['due_date'],'time_end'=>$contactdata['time_end']);
                }
            }
        }
    }
    pushlog("--- END getAllEvents ---");
    return $arr_contact;
}
function getAllDeals($vtod) {
    $query = "SELECT COUNT(*) FROM Potentials;";
    $potentialCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $potentialCount = intval($rs[0]['count']);
    }

    $arr_poten = [];
    if ($potentialCount < 200) {
        $sql = "SELECT contact_id FROM Potentials;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $poten_val) {
                if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['contact_id']] = $poten_val['id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $potentialCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT contact_id FROM Potentials ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $poten_val) {
                if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['contact_id']] = $poten_val['id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            $flag++;
            $offset = $value;

            $sql = "SELECT contact_id FROM Potentials ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $poten_val) {
                    if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['contact_id']] = $poten_val['id'];
                }
            }
        }
    }
    return $arr_poten;
}

function linkEventToRecord(dhvt $vtod,$vtod_config_url,$eventId,$potentialId,$modulename) {
    $vtod->addRelated($eventId,$potentialId, $modulename);
}


function curlPost($url, $data = null, $headers = null) {
    $ch = curl_init($url);
    //curl_setopt($ch, CURLOPT_HEADER, FALSE);
    if($headers)
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, TRUE);
    if (is_array($data)) {
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    }
    $userAgent = 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:40.0) Gecko/20100101 Firefox/40.0';
    curl_setopt($ch, CURLOPT_USERAGENT, $userAgent);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FAILONERROR, TRUE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLINFO_HEADER_OUT, TRUE);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
    curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
    if(curl_errno($ch)){
        echo curl_error($ch);
        return false;
    }
    $response = curl_exec($ch);
    curl_close($ch);
    return $response;
}

function pushlog($var)
{
    $content = date("Y-m-d H:i:s") . "\t";
    if (is_array($var) || is_object($var)) {
        $content .= print_r($var, true);
    } else {
        $content .= $var;
    }
    echo $content .= "\n";
    file_put_contents("logs/53234_importEvents_".date('Ymd').".log", $content, FILE_APPEND);
}
function formateCSVData($file_name) {
    $data =  $header = array();
    $i = 0;
    $file = fopen($file_name, 'r');
    while (($line = fgetcsv($file)) !== FALSE) {
        if( $i==0 ) {
            foreach ($line as $k=>$val){
                $val = ($val == '') ? 'header_'.$k : $val;
                $header[$k] = strtolower(str_replace(' ','',$val));
            }
        } else {
            $data[] = $line;
        }
        $i++;
    }
    fclose($file);
    foreach ($data as $key => $_value) {
        $new_item = array();
        foreach ($_value as $key => $value) {
            $new_item[ $header[$key] ] =$value;
        }
        $_data[] = $new_item;
    }
    return $_data;
}
