<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL  & ~(E_STRICT|E_NOTICE| E_WARNING | E_PARSE |E_DEPRECATED) );

chdir(dirname(__FILE__));
require "../init.php";

$vtod = init_vtod();
$vtod->echo_debug=true;
$vtod_config_url = $vtod_config["url"];

$query = "SELECT COUNT(*) FROM Contacts WHERE cf_contacts_updateconfirmationurl !='1';";
$contactCount = 0;
$rs = $vtod->query($query);

if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
    $contactCount = intval($rs[0]['count']);
}

$arr_contact = [];
if ($contactCount < 200) {
    $sql = "SELECT id FROM Contacts WHERE cf_contacts_updateconfirmationurl !='1';";
    $result = $vtod->query($sql);
    if (is_array($result) && count($result) > 0) {
        foreach ($result as $key => $contact_val) {
            updateConfirmUrlContact($vtod,$vtod_config_url,$contact_val['id']);
        }
    }
} else {
    $offsetArr = array();
    for ($i = 1; $i <= $contactCount; $i++) {
        if ($i >= 200 && (($i % 200) == 0)) {
            $offsetArr[] = $i;
        }
    }

    $offset = 0;
    $limit = 200;
    $flag = 0;

    $sql = "SELECT id FROM Contacts WHERE cf_contacts_updateconfirmationurl !='1' ORDER BY createdtime ASC LIMIT 0,$limit;";
    $result = $vtod->query($sql);

    if (is_array($result) && count($result) > 0) {
        foreach ($result as $key => $contact_val) {
            updateConfirmUrlContact($vtod,$vtod_config_url,$contact_val['id']);
        }
    }

    foreach ($offsetArr as $key => $value) {
        $flag++;
        $offset = $value;

        $sql = "SELECT id FROM Contacts WHERE cf_contacts_updateconfirmationurl !='1' ORDER BY createdtime ASC LIMIT $offset,$limit;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $contact_val) {
                updateConfirmUrlContact($vtod,$vtod_config_url,$contact_val['id']);
            }
        }
    }
}

echo "Done.";
exit;

function updateConfirmUrlContact($vtod,$vtod_config_url,$contactId) {
    $org_name = '';
    if($contactId) {
        $contactRecord = $vtod->retrieve($contactId);
        if ($contactRecord['cf_contacts_updateconfirmationurl'] != '1') {
            if ($contactRecord['account_id']) {
                $orgRecord = $vtod->retrieve($contactRecord['account_id']);
                if ($orgRecord['accountname']) $org_name = $orgRecord['accountname'];
            }
            if ($contactRecord['cf_contacts_confirmationform'] == 'Workplace') {
                $confirm_url = "https://forms.theresilienceproject.com.au/workplace-confirmation-form/?org_name=" . rawurlencode($org_name) . "&contact_first_name=" . rawurlencode($contactRecord['firstname']) . "&contact_last_name=" . rawurlencode($contactRecord['lastname']) . "&contact_email=" . $contactRecord['email'] . "&address=" . rawurlencode($contactRecord['cf_contacts_address']) . "&city=" . rawurlencode($contactRecord['cf_contacts_city']) . "&state=" . rawurlencode($contactRecord['cf_contacts_statenew']) . "&zip_code=" . $contactRecord['cf_contacts_zipcode'];
            } else if ($contactRecord['cf_contacts_confirmationform'] == 'New School') {
                $confirm_url = "https://forms.theresilienceproject.com.au/new-schools-confirmation/?org_name=" . rawurlencode($org_name) . "&contact_first_name=" . rawurlencode($contactRecord['firstname']) . "&contact_last_name=" . rawurlencode($contactRecord['lastname']) . "&contact_email=" . $contactRecord['email'] . "&address=" . rawurlencode($contactRecord['cf_contacts_address']) . "&city=" . rawurlencode($contactRecord['cf_contacts_city']) . "&state=" . rawurlencode($contactRecord['cf_contacts_statenew']) . "&zip_code=" . $contactRecord['cf_contacts_zipcode'];
            } else if ($contactRecord['cf_contacts_confirmationform'] == 'Early Years') {
                $confirm_url = "https://forms.theresilienceproject.com.au/early-years-program-confirmation/?org_name=" . rawurlencode($org_name) . "&contact_first_name=" . rawurlencode($contactRecord['firstname']) . "&contact_last_name=" . rawurlencode($contactRecord['lastname']) . "&contact_email=" . $contactRecord['email'] . "&address=" . rawurlencode($contactRecord['cf_contacts_address']) . "&city=" . rawurlencode($contactRecord['cf_contacts_city']) . "&state=" . rawurlencode($contactRecord['cf_contacts_statenew']) . "&zip_code=" . $contactRecord['cf_contacts_zipcode'];
            } else if ($contactRecord['cf_contacts_confirmationform'] == 'Existing School (F2F/Digital)') {
                $confirm_url = "https://forms.theresilienceproject.com.au/existing-school-confirmation-form-new/?org_name=" . rawurlencode($org_name) . "&contact_first_name=" . rawurlencode($contactRecord['firstname']) . "&contact_last_name=" . rawurlencode($contactRecord['lastname']) . "&contact_email=" . $contactRecord['email'] . "&address=" . rawurlencode($contactRecord['cf_contacts_address']) . "&city=" . rawurlencode($contactRecord['cf_contacts_city']) . "&state=" . rawurlencode($contactRecord['cf_contacts_statenew']) . "&zip_code=" . $contactRecord['cf_contacts_zipcode'];
            } else if ($contactRecord['cf_contacts_confirmationform'] == 'Existing School (Digital Only)') {
                $confirm_url = "https://forms.theresilienceproject.com.au/existing-school-confirmation-form-new-digital/?org_name=" . rawurlencode($org_name) . "&contact_first_name=" . rawurlencode($contactRecord['firstname']) . "&contact_last_name=" . rawurlencode($contactRecord['lastname']) . "&contact_email=" . $contactRecord['email'] . "&address=" . rawurlencode($contactRecord['cf_contacts_address']) . "&city=" . rawurlencode($contactRecord['cf_contacts_city']) . "&state=" . rawurlencode($contactRecord['cf_contacts_statenew']) . "&zip_code=" . $contactRecord['cf_contacts_zipcode'];
            }
            $contactRecord['cf_contacts_updateconfirmationurl'] = '1';
            $contactRecord['cf_contacts_confirmationurlnew'] = $confirm_url;
            $objectJson = json_encode($contactRecord);
            $params = array(
                "sessionName" => $vtod->sessionId,
                "operation" => 'update',
                "element" => $objectJson
            );
            sleep(1);
            try {
                $res = curlPost($vtod_config_url . "webservice.php", $params);
                $response = json_decode($res, 1);
                if (!$response['error']) {
                    pushlog("Update Contact: " . $contactRecord['id'] . " success.");
                } else {
                    pushlog($response['error']['message']);
                }
            } catch (Exception $e) {
                pushlog($e->getMessage());
            }
        }
    }
}

function curlPost($url, $data = null, $headers = null) {
    $ch = curl_init($url);
    //curl_setopt($ch, CURLOPT_HEADER, FALSE);
    if($headers)
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, TRUE);
    if (is_array($data)) {
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    }
    $userAgent = 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:40.0) Gecko/20100101 Firefox/40.0';
    curl_setopt($ch, CURLOPT_USERAGENT, $userAgent);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FAILONERROR, TRUE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLINFO_HEADER_OUT, TRUE);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
    curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
    if(curl_errno($ch)){
        echo curl_error($ch);
        return false;
    }
    $response = curl_exec($ch);
    curl_close($ch);
    return $response;
}

function pushlog($var)
{
    $content = date("Y-m-d H:i:s") . "\t";
    if (is_array($var) || is_object($var)) {
        $content .= print_r($var, true);
    } else {
        $content .= $var;
    }
    $content .= "\n";
    file_put_contents(dirname(__FILE__) . "/53783_updateConfirmationUrlContacts".date('Ymd').".log", $content, FILE_APPEND);
}