<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL  & ~(E_STRICT|E_NOTICE| E_WARNING | E_PARSE |E_DEPRECATED) );

chdir(dirname(__FILE__));
require "../init.php";

$vtod = init_vtod();
$vtod->echo_debug=true;
$vtod_config_url = $vtod_config["url"];

$query = "SELECT COUNT(*) FROM Potentials;";
$dealCount = 0;
$rs = $vtod->query($query);

if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
    $dealCount = intval($rs[0]['count']);
}
$arr_deal = [];
if ($dealCount < 200) {
    $sql = "SELECT * FROM Potentials;";
    $result = $vtod->query($sql);
    if (is_array($result) && count($result) > 0) {
        foreach ($result as $key => $value) {
            updateExtraOptions($vtod,$vtod_config_url,$value);
        }
    }
} else {
    $offsetArr = array();
    for ($i = 1; $i <= $dealCount; $i++) {
        if ($i >= 200 && (($i % 200) == 0)) {
            $offsetArr[] = $i;
        }
    }

    $offset = 0;
    $limit = 200;
    $flag = 0;

    $sql = "SELECT * FROM Potentials ORDER BY createdtime ASC LIMIT 0,$limit;";
    $result = $vtod->query($sql);

    if (is_array($result) && count($result) > 0) {
        foreach ($result as $key => $value) {
            updateExtraOptions($vtod,$vtod_config_url,$value);
        }
    }

    foreach ($offsetArr as $key => $value) {
        $flag++;
        $offset = $value;

        $sql = "SELECT * FROM Potentials ORDER BY createdtime ASC LIMIT $offset,$limit;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $value) {
                updateExtraOptions($vtod,$vtod_config_url,$value);
            }
        }
    }
}

echo "Done.";
exit;

function updateExtraOptions($vtod,$vtod_config_url,$dealRecord) {
    $listExtraOptions = [];
    if($dealRecord['cf_potentials_extraupdate'] != '1') {
        if ($dealRecord['cf_2181'] == '1') {
            $listExtraOptions[] = 'Teacher Wellbeing Program';
        }
        if ($dealRecord['cf_2183'] == '1') {
            $listExtraOptions[] = 'Teacher Wellbeing WS (self)';
        }
        if ($dealRecord['cf_2185'] == '1') {
            $listExtraOptions[] = 'Teacher Wellbeing Web (self)';
        }
        if ($dealRecord['cf_2580'] == '1') {
            $listExtraOptions[] = 'Teacher Wellbeing WS (other)';
        }
        if ($dealRecord['cf_2189'] == '1') {
            $listExtraOptions[] = 'Teacher Wellbeing Web (other)';
        }
        if ($dealRecord['cf_2191'] == '1') {
            $listExtraOptions[] = 'Teacher Wellbeing Series';
        }
        if ($dealRecord['cf_potentials_extraoptions2022trpinactionws'] == '1') {
            $listExtraOptions[] = 'TRP In Action WS';
        }
        if ($dealRecord['cf_potentials_extraoptions2022trpinactionweb'] == '1') {
            $listExtraOptions[] = 'TRP In Action Web';
        }
        if ($dealRecord['cf_2197'] == '1') {
            $listExtraOptions[] = 'Connected Parenting WS';
        }
        if ($dealRecord['cf_2199'] == '1') {
            $listExtraOptions[] = 'Connected Parenting Web';
        }
        if ($dealRecord['cf_2201'] == '1') {
            $listExtraOptions[] = 'Resilience Profile WS for Parents';
        }
        if ($dealRecord['cf_potentials_extraoptions2022facilitateddigital'] == '1') {
            $listExtraOptions[] = 'Facilitated Digital';
        }
        if ($dealRecord['cf_2205'] == '1') {
            $listExtraOptions[] = 'Discovering Resilience Pre-record';
        }
        if ($dealRecord['cf_2207'] == '1') {
            $listExtraOptions[] = 'Discovering Resilience Webinar';
        }
        if ($dealRecord['cf_2209'] == '1') {
            $listExtraOptions[] = 'Discovering Resilience In-Person';
        }
        if ($dealRecord['cf_2211'] == '1') {
            $listExtraOptions[] = 'Digital Wellbeing Series';
        }
        if ($dealRecord['cf_2213'] == '1') {
            $listExtraOptions[] = 'Authentic Connection Pre-record';
        }
        if ($dealRecord['cf_2215'] == '1') {
            $listExtraOptions[] = 'Authentic Connection Webinar';
        }
        if ($dealRecord['cf_2584'] == '1') {
            $listExtraOptions[] = 'Authentic Connection In-Person';
        }
        if ($dealRecord['cf_2219'] == '1') {
            $listExtraOptions[] = 'Workplace Wellbeing WS (self)';
        }
        if ($dealRecord['cf_2221'] == '1') {
            $listExtraOptions[] = 'Workplace Wellbeing Web (self)';
        }
        if ($dealRecord['cf_2223'] == '1') {
            $listExtraOptions[] = 'Workplace Wellbeing WS (other)';
        }
        if ($dealRecord['cf_2225'] == '1') {
            $listExtraOptions[] = 'Workplace Wellbeing Web (other)';
        }
        if ($dealRecord['cf_potentials_extraoptions2022workplacecpws'] == '1') {
            $listExtraOptions[] = 'Workplace CP WS';
        }
        if ($dealRecord['cf_potentials_extraoptions2022workplacecpweb'] == '1') {
            $listExtraOptions[] = 'Workplace CP Web';
        }
        if ($dealRecord['cf_2586'] == '1') {
            $listExtraOptions[] = 'Workplace CP Digital Series';
        }
        if (count($listExtraOptions) > 0) {
            $dealRecord['cf_potentials_2022extraoptions'] = implode(" |##| ", $listExtraOptions);
            $dealRecord['cf_potentials_extraupdate'] = '1';
            $objectJson = json_encode($dealRecord);
            $params = array(
                "sessionName" => $vtod->sessionId,
                "operation" => 'update',
                "element" => $objectJson
            );
            try {
                $res = curlPost($vtod_config_url . "webservice.php", $params);
                $response = json_decode($res, 1);
                if (!$response['error']) {
                    pushlog("Update Deal: " . $dealRecord['id'] . " success.");
                } else {
                    pushlog($response['error']['message']);
                }
            } catch (Exception $e) {
                pushlog($e->getMessage());
            }
        }
    }
}

function curlPost($url, $data = null, $headers = null) {
    $ch = curl_init($url);
    //curl_setopt($ch, CURLOPT_HEADER, FALSE);
    if($headers)
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, TRUE);
    if (is_array($data)) {
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    }
    $userAgent = 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:40.0) Gecko/20100101 Firefox/40.0';
    curl_setopt($ch, CURLOPT_USERAGENT, $userAgent);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FAILONERROR, TRUE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLINFO_HEADER_OUT, TRUE);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
    curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
    if(curl_errno($ch)){
        echo curl_error($ch);
        return false;
    }
    $response = curl_exec($ch);
    curl_close($ch);
    return $response;
}

function pushlog($var)
{
    $content = date("Y-m-d H:i:s") . "\t";
    if (is_array($var) || is_object($var)) {
        $content .= print_r($var, true);
    } else {
        $content .= $var;
    }
    $content .= "\n";
    file_put_contents(dirname(__FILE__) . "/54238_updateExtraOptionDeals".date('Ymd').".log", $content, FILE_APPEND);
}