<?php
/**
 * Created by Boru
 * User: tracy.lynn
 * Date: 5/26/2022
 * Time: 3:48 PM
 */

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL  & ~(E_STRICT|E_NOTICE| E_WARNING | E_PARSE |E_DEPRECATED) );

chdir(dirname(__FILE__));
require "../init.php";

$vtod = init_vtod();
$vtod_config_url = $vtod_config["url"];

$listDeals = getAllDeals($vtod);
if(count($listDeals) >0) {
    foreach($listDeals as $potentialId => $contactId) {
        $listEvents = getEventByContactId($vtod,$contactId);
        if(count($listEvents)>0) {
            foreach($listEvents as $event_val) {
                if($event_val['id']) {
                    linkEventToDeal($vtod,$vtod_config_url,$event_val['id'],$potentialId);
                }
            }
        }
    }
}
echo "Done.";

function getEventByContactId($vtod,$event_id) {
    $query_prod = sprintf("SELECT id FROM Events WHERE contact_id='%s';", $event_id);
    $events = $vtod->query($query_prod);
    if (count($events) >0) {
        return $events;
    }
}

function getAllDeals($vtod) {
    $query = "SELECT COUNT(*) FROM Potentials;";
    $potentialCount = 0;
    $rs = $vtod->query($query);

    if (is_array($rs) && (isset($rs[0]['count']) && $rs[0]['count'] > 0)) {
        $potentialCount = intval($rs[0]['count']);
    }

    $arr_poten = [];
    if ($potentialCount < 200) {
        $sql = "SELECT contact_id FROM Potentials;";
        $result = $vtod->query($sql);
        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $poten_val) {
                if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['id']] = $poten_val['contact_id'];
            }
        }
    } else {
        $offsetArr = array();
        for ($i = 1; $i <= $potentialCount; $i++) {
            if ($i >= 200 && (($i % 200) == 0)) {
                $offsetArr[] = $i;
            }
        }

        $offset = 0;
        $limit = 200;
        $flag = 0;

        $sql = "SELECT contact_id FROM Potentials ORDER BY createdtime DESC LIMIT 0,$limit;";
        $result = $vtod->query($sql);

        if (is_array($result) && count($result) > 0) {
            foreach ($result as $key => $poten_val) {
                if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['id']] = $poten_val['contact_id'];
            }
        }

        foreach ($offsetArr as $key => $value) {
            $flag++;
            $offset = $value;

            $sql = "SELECT contact_id FROM Potentials ORDER BY createdtime DESC LIMIT $offset,$limit;";
            $result = $vtod->query($sql);
            if (is_array($result) && count($result) > 0) {
                foreach ($result as $key => $poten_val) {
                    if(!empty($poten_val['contact_id'])) $arr_poten[$poten_val['id']] = $poten_val['contact_id'];
                }
            }
        }
    }
    return $arr_poten;
}

function linkEventToDeal(dhvt $vtod,$vtod_config_url,$eventId,$potentialId) {
    pushlog($eventId.','.$potentialId);
    $vtod->addRelated($eventId,$potentialId, 'Potentials');
}


function curlPost($url, $data = null, $headers = null) {
    $ch = curl_init($url);
    //curl_setopt($ch, CURLOPT_HEADER, FALSE);
    if($headers)
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, TRUE);
    if (is_array($data)) {
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    }
    $userAgent = 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:40.0) Gecko/20100101 Firefox/40.0';
    curl_setopt($ch, CURLOPT_USERAGENT, $userAgent);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FAILONERROR, TRUE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLINFO_HEADER_OUT, TRUE);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
    curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
    if(curl_errno($ch)){
        echo curl_error($ch);
        return false;
    }
    $response = curl_exec($ch);
    curl_close($ch);
    return $response;
}

function pushlog($var)
{
    $content = date("Y-m-d H:i:s") . "\t";
    if (is_array($var) || is_object($var)) {
        $content .= print_r($var, true);
    } else {
        $content .= $var;
    }
    $content .= "\n";
    file_put_contents(dirname(__FILE__) . "/53234_importDeals_".date('Ymd').".log", $content, FILE_APPEND);
}