<?php

class VT9Api {
	public $url;
	public $userName;
	public $accessKey;

	function __construct($url, $userName, $accessKey){
		$this->url = $url;
		$this->userName = $userName;
		$this->accessKey = $accessKey;
	}

	public function getData($api_name, $data){
		$base64User = base64_encode($this->userName.':'.$this->accessKey);
		$headers = array("Authorization: Basic $base64User");
		$response = $this->curlGet($this->url.$api_name, $data, $headers);
		return json_decode($response, true);
	}

    public function create($api_name, $data){
        $base64User = base64_encode($this->userName.':'.$this->accessKey);
        $headers = array("Authorization: Basic $base64User");
        $response = $this->curlPost($this->url.$api_name, $data, $headers);
        return json_decode($response, true);
    }

    public function update($api_name, $data){
        $base64User = base64_encode($this->userName.':'.$this->accessKey);
        $headers = array("Authorization: Basic $base64User");
        $response = $this->curlPut($this->url.$api_name, $data, $headers);
        return json_decode($response, true);
    }

	public function postData($api_name, $data){
		$base64User = base64_encode($this->userName.':'.$this->accessKey);
		$headers = array("Authorization: Basic $base64User");
        $response = $this->curlPost($this->url.'restapi/V1/ApiDesigner/api/'.$api_name, $data, $headers);
		return json_decode($response, true);
	}

	function curlGet($url, $data = null, $headers = null){
		$ch = curl_init($url);
		if (is_array($data)) {
			$url = $url .'?'. http_build_query($data);
		}
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_ENCODING,'');
		curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
		curl_setopt($ch, CURLOPT_TIMEOUT, 0);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
		if($headers)
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

		$response = curl_exec($ch);

		curl_close($ch);
		return $response;
	}
	function curlPost($url, $data = null, $headers = null) {
        $curl = curl_init();
        if($headers) {
            curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => $data,
                CURLOPT_HTTPHEADER => $headers
            ));
        } else {
            curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => $data
            ));
        }
        $response = curl_exec($curl);
        return $response;
	}

    function curlPut($url, $data = null, $headers = null) {
        if (is_array($data)) {
            $url = $url .'?'. http_build_query($data);
        }
        $ch = curl_init($url);
        if($headers)
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');

        $userAgent = 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:40.0) Gecko/20100101 Firefox/40.0';
        curl_setopt($ch, CURLOPT_USERAGENT, $userAgent);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_FAILONERROR, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLINFO_HEADER_OUT, TRUE);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
        curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
        if(curl_errno($ch)){
            echo curl_error($ch);
            return false;
        }
        $response = curl_exec($ch);
        curl_close($ch);
        return $response;
    }
}
