<?php
/**
 * Wordpress webhook to get order from Woocommerce and post it in vtiger
 *
 * taskid: 54815
 * User: rprajapati
 * Date: 20/10/22
 * Time: 12:21 PM
 */


// die("Remove this when push to prod.");
//Remove above die when need to run webhook


header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: PUT, GET, POST");
header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept");

chdir(dirname(__FILE__));
require_once "../init.php";

//========Debugging=============
error_reporting(0);
//ini_set('display_errors', 'on');
//error_reporting(E_ALL); // STRICT DEVELOPMENT
//echo "<pre>";

$vtod = init_vtod();
global $dbh;

putlogwebhook("========== START ==========");

$postData = json_decode(file_get_contents("php://input"), true);
$schoolName = '';
$lineItems = [];

putlogwebhook("New order to process, process data:");
putlogwebhook($postData);

/*(
    [parent_id] => 0
    [status] => processing
    [currency] => AUD
    [version] => 7.5.1
    [prices_include_tax] => 
    [date_created] => 2023-05-08T10:42:35
    [date_modified] => 2023-05-08T14:56:25
    [discount_total] => 0.00
    [discount_tax] => 0.00
    [shipping_total] => 0.00
    [shipping_tax] => 0.00
    [cart_tax] => 197.20
    [total] => 2169.20
    [total_tax] => 197.20
    [customer_id] => 0
    [order_key] => wc_order_vVWttL5UaC74Q
    [billing] => Array
        (
            [first_name] => Navneet
            [last_name] => Kaur
            [company] => Nido Early School Wyndham Vale
            [address_1] => 9 Welcome Parade
            [address_2] => 
            [city] => Wyndhamvale
            [state] => VIC
            [postcode] => 3024
            [country] => AU
            [email] => esm.wyndhamvale@nido.edu.au
            [phone] => 0370199398
        )

    [shipping] => Array
        (
            [first_name] => Navneet
            [last_name] => Kaur
            [company] => Nido Early School Wyndham Vale
            [address_1] => 9 Welcome Parade
            [address_2] => 
            [city] => Wyndhamvale
            [state] => VIC
            [postcode] => 3024
            [country] => AU
            [phone] => 
        )

    [payment_method] => bacs
    [line_items] => Array
        (
            [0] => Array
                (
                    [id] => 3609
                    [name] => Engage: Early Years Teaching and Learning Program
                    [product_id] => 58
                    [variation_id] => 0
                    [quantity] => 1
                    [tax_class] => 
                    [subtotal] => 0.00
                    [subtotal_tax] => 0.00
                    [total] => 0.00
                    [total_tax] => 0.00
                    [taxes] => Array
                        (
                            [0] => Array
                                (
                                    [id] => 1
                                    [total] => 0
                                    [subtotal] => 0
                                )

                        )
                        
[payment_url] => https://curriculum.theresilienceproject.com.au/checkout/order-pay/688/?pay_for_order=true&key=wc_order_WUjddTmpbWezA
*/

$woocommerce_id = $postData['id'];
// exit;

$tmpDates = explode('T', $postData['date_created']);
$curriculumordered = $tmpDates[0];


$schoolName = $postData['billing']['company'];
if (empty($schoolName)){
    foreach ($postData['meta_data'] as $otherData) {
        if ($otherData['key'] == 'school_name') {
            $schoolName = $otherData['value'];
        }
    }
    
}
// check payment_url
$url = $postData['payment_url'];
$array=parse_url($url);
$array['host']=explode('.', $array['host']);
$buildname = $array['host'][0]; // returns 'sub'


$early_years = false; 
$qty_early_year = NULL;
if (strpos($postData['payment_url'], 'early-years.theresilienceproject') !== false) {
    $early_years = TRUE; 
}
foreach ($postData['line_items'] as $lineItem) {
    if (strpos($lineItem['name'], 'Student Journal') !== false) {
        $lineItems[] = $lineItem['name'];
    }
    // Early Years Children’s Journal
    if ($early_years && strpos($lineItem['name'], 'Early Years Children’s Journal') !== false){
        $qty_early_year = $lineItem['quantity'] ;
    }
}

if (!empty($schoolName) && $postData['status'] == 'processing') {
    putlogwebhook("Order have processing status, doing process");
    // check by buildname first 
    $sqlGet = "SELECT * FROM boru_woocommerce_order WHERE woocommerce_id = ? and buildname = ?";
    $dataCheck = $dbh->getSingle($sqlGet, array($woocommerce_id,$buildname));
    if (empty($dataCheck) && $buildname == 'curriculum' ){
        $sqlGet = "SELECT * FROM boru_woocommerce_order WHERE woocommerce_id = ?";
        $dataCheck = $dbh->getSingle($sqlGet, array($woocommerce_id));
    }
    

    if (!empty($dataCheck['crm_id'])){
        putlogwebhook("Order already processed with result:");
        putlogwebhook($dataCheck);
        putlogwebhook("========== END==========");
        die();
    }

    try {
        $accountId = '';

        $queryOrg = sprintf("SELECT * FROM Accounts WHERE accountname='%s'; ", addslashes( $schoolName ) );
        $resultOrg = $vtod->query($queryOrg);

        if (count($resultOrg) == 0) {
            putlogwebhook("No account found in crm with name, checking other account-> " . $schoolName);

            $queryOrg1 = "SELECT * FROM Accounts WHERE accountname='School Name Other'; ";
            $resultOrg = $vtod->query($queryOrg1);

            if (count($resultOrg) > 0) {
                putlogwebhook("Other account found using other account.");
                $accountId = $resultOrg[0]['id'];
            }
        } else {
            $accountId = $resultOrg[0]['id'];
        }

        if (empty($accountId)) {
            putlogwebhook("No matching account or other accout found, creating new other account.");

            
            $arr_org['accountname'] = 'School Name Other';
            $arr_org['cf_accounts_organisationtype'] = 'School';
            $arr_org['assigned_user_id'] = $vtod->userId;

            try {
                $dataCOrg = $vtod->create("Accounts", $arr_org);

                if (!empty($dataCOrg['id'])) {
                    putlogwebhook("Other accoutn created with id -> " . $dataCOrg['id']);

                    $accountId = $dataCOrg['id'];
                }
            } catch (Exception $e) {
                putlogwebhook('Error while creating new Other school Account in CRM. error = ' . $e->getMessage());
            }
            /**/
        }

        if (!empty($accountId)) {
            putlogwebhook("Account found in system, accoutn id -> " . $accountId);

            
            if (empty($resultOrg[0]['cf_accounts_selectedyearlevels'])) {
                $selectedyearlevels = [];

                foreach ($lineItems as $selectedYear) {
                    $selectedyearlevels[] = trim(str_replace('Student Journal', '', $selectedYear));
                }

                $newOrg = array(
                    'id' => $accountId,
                    'cf_accounts_curriculumordered' => $curriculumordered,
                    'cf_accounts_selectedyearlevels' => implode(' |##| ', $selectedyearlevels)
                );
                if ($early_years)
                {
                    $selectedyearlevels[] = 'Early Years';
                    $newOrg['cf_accounts_selectedyearlevels'] = implode(' |##| ', $selectedyearlevels);
                    $newOrg['cf_accounts_totalresourcesordered' ] = $qty_early_year;
                }
                putlogwebhook("Updating account in  crm.");
                putlogwebhook($newOrg);

                try {
                    $resUpdate = $vtod->revise($newOrg);

                    $sql = "INSERT INTO boru_woocommerce_order (woocommerce_id, crm_id, buildname, sync_date) VALUES (?, ?, ?,NOW())";
                    $dbh->run($sql, array($postData['id'], $resUpdate['id'],$buildname));

                    putlogwebhook("Success, account updated.");

                } catch (Exception $e) {
                    putlogwebhook('Error while updating Account in CRM. error = ' . $e->getMessage());
                }
            } else {
                putlogwebhook("Account already haev schools in it,, not updating it. school -> " . $resultOrg[0]['cf_accounts_selectedyearlevels']);
            }
            /**/
        } else {
            putlogwebhook('No Account found for name and no new accout created = ' . $schoolName);
        }
    } catch (Exception $e) {
        putlogwebhook('Error while fetching account from CRM. error = ' . $e->getMessage());
    }
} else {
    if (empty($schoolName)) {
        putlogwebhook('No school name in order');
    }else{
        putlogwebhook('Order status is not processing');
    }
}
putlogwebhook("========== END==========");


function putlogwebhook($var)
{
    $content = date("Y-m-d H:i:s") . "\t";
    if (is_array($var) || is_object($var)) {
        $content .= print_r($var, true);
    } else {
        $content .= $var;
    }
    $content .= "\n";
//     echo $content;
//     echo "<br>";
    if (!file_exists(dirname(__FILE__) . "/Order.log")) {
        @touch(dirname(__FILE__) . "/Order.log", 0777, true);
    }
    file_put_contents(dirname(__FILE__) . "/Order.log", $content, FILE_APPEND);
}