<?php
/**
 * Wordpress webhook to get order from Woocommerce and post it in vtiger
 *
 * taskid: 54815
 * User: rprajapati
 * Date: 20/10/22
 * Time: 12:21 PM
 */


// die("Remove this when push to prod.");
//Remove above die when need to run webhook


header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: PUT, GET, POST");
header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept");

chdir(dirname(__FILE__));
require_once "../init.php";

//========Debugging=============
// error_reporting(0);
ini_set('display_errors', 'on');
error_reporting(E_ALL); // STRICT DEVELOPMENT
echo "<pre>";

$vtod = init_vtod();
global $dbh;
$schoolName = "Colo Vale Public School";// "St Anthony's Early Learning Centre";
$queryOrg = sprintf("SELECT * FROM Accounts WHERE accountname='%s'; ", addslashes( $schoolName ) );
echo $queryOrg; //exit;
$resultOrg = $vtod->query($queryOrg);
print_r( $resultOrg);
exit;

putlogwebhook("========== START ==========");

$postData = json_decode(file_get_contents("php://input"), true);
$schoolName = '';
$lineItems = [];

putlogwebhook("New order to process, process data:");
putlogwebhook($postData);

/*(
    [id] => 567
    [parent_id] => 0
    [status] => refunded
    [currency] => AUD
    [version] => 7.0.0
    [prices_include_tax] => 1
    [date_created] => 2022-10-17T14:20:32
    [date_modified] => 2022-10-25T19:07:35
    [discount_total] => 0.00
    [discount_tax] => 0.00
    [shipping_total] => 16.36
    [shipping_tax] => 1.64
    [cart_tax] => 30.40
    [total] => 352.40
    [total_tax] => 32.04
    [customer_id] => 3
    [order_key] => wc_order_hkVDD9KMRFgAY
    [billing] => Array
        (
            [first_name] => Dawn **TEST***
            [last_name] => Maxa
            [company] => The Resilience Project
            [address_1] => 81 Sackville Street
            [address_2] => 
            [city] => Collingwood
            [state] => VIC
            [postcode] => 3066
            [country] => AU
            [email] => hello@theresilienceproject.com.au
            [phone] => 0433333333
        )
     [meta_data] => Array
        (
            [0] => Array
               
     [line_items] => Array
        (
            [0] => Array
                (
                    [id] => 882
                    [name] => Foundation Student Journal
                    [product_id] => 25
                    [variation_id] => 0
                    [quantity] => 3
                    [tax_class] => 
                    [subtotal] => 57.00
                    [subtotal_tax] => 5.70
                    [total] => 57.00
                    [total_tax] => 5.70
                    [taxes] => Array
                        (
                            [0] => Array
                                (
                                    [id] => 1
                                    [total] => 5.7
                                    [subtotal] => 5.7
                                )

                        )

                    [meta_data] => Array
                        (   
*/

$woocommerce_id = $postData['id'];
// exit;

$tmpDates = explode('T', $postData['date_created']);
$curriculumordered = $tmpDates[0];


$schoolName = $postData['billing']['company'];
if (empty($schoolName)){
    foreach ($postData['meta_data'] as $otherData) {
        if ($otherData['key'] == 'school_name') {
            $schoolName = $otherData['value'];
        }
    }
    
}
// check payment_url
$early_years = false; 
$qty_early_year = NULL;
if (strpos($postData['payment_url'], 'early-years.theresilienceproject') !== false) {
    $early_years = TRUE; 
}
foreach ($postData['line_items'] as $lineItem) {
    if (strpos($lineItem['name'], 'Student Journal') !== false) {
        $lineItems[] = $lineItem['name'];
    }
    // Early Years Children’s Journal
    if ($early_years && strpos($lineItem['name'], 'Early Years Children’s Journal') !== false){
        $qty_early_year = $lineItem['quantity'] ;
    }
}

if (!empty($schoolName) && $postData['status'] == 'processing') {
    putlogwebhook("Order have processing status, doing process");

    $sqlGet = "SELECT * FROM boru_woocommerce_order WHERE woocommerce_id = ?";
    $dataCheck = $dbh->getSingle($sqlGet, array($woocommerce_id));

    if (!empty($dataCheck['crm_id'])){
        putlogwebhook("Order already processed with result:");
        putlogwebhook($dataCheck);
        putlogwebhook("========== END==========");
        die();
    }

    try {
        $accountId = '';

        $queryOrg = sprintf('SELECT * FROM Accounts WHERE accountname="%s"; ', $schoolName);
        $resultOrg = $vtod->query($queryOrg);

        if (count($resultOrg) == 0) {
            putlogwebhook("No account found in crm with name, checking other account-> " . $schoolName);

            $queryOrg1 = "SELECT * FROM Accounts WHERE accountname='School Name Other'; ";
            $resultOrg = $vtod->query($queryOrg1);

            if (count($resultOrg) > 0) {
                putlogwebhook("Other account found using other account.");
                $accountId = $resultOrg[0]['id'];
            }
        } else {
            $accountId = $resultOrg[0]['id'];
        }

        if (empty($accountId)) {
            putlogwebhook("No matching account or other accout found, creating new other account.");

            
            $arr_org['accountname'] = 'School Name Other';
            $arr_org['cf_accounts_organisationtype'] = 'School';
            $arr_org['assigned_user_id'] = $vtod->userId;

            try {
                $dataCOrg = $vtod->create("Accounts", $arr_org);

                if (!empty($dataCOrg['id'])) {
                    putlogwebhook("Other accoutn created with id -> " . $dataCOrg['id']);

                    $accountId = $dataCOrg['id'];
                }
            } catch (Exception $e) {
                putlogwebhook('Error while creating new Other school Account in CRM. error = ' . $e->getMessage());
            }
            /**/
        }

        if (!empty($accountId)) {
            putlogwebhook("Account found in system, accoutn id -> " . $accountId);

            
            if (empty($resultOrg[0]['cf_accounts_selectedyearlevels'])) {
                $selectedyearlevels = [];

                foreach ($lineItems as $selectedYear) {
                    $selectedyearlevels[] = trim(str_replace('Student Journal', '', $selectedYear));
                }

                $newOrg = array(
                    'id' => $accountId,
                    'cf_accounts_curriculumordered' => $curriculumordered,
                    'cf_accounts_selectedyearlevels' => implode(' |##| ', $selectedyearlevels)
                );
                if ($early_years)
                {
                    $selectedyearlevels[] = 'Early Years';
                    $newOrg['cf_accounts_selectedyearlevels'] = implode(' |##| ', $selectedyearlevels);
                    $newOrg['cf_accounts_totalresourcesordered' ] = $qty_early_year;
                }
                putlogwebhook("Updating account in  crm.");
                putlogwebhook($newOrg);

                try {
                    $resUpdate = $vtod->revise($newOrg);

                    $sql = "INSERT INTO boru_woocommerce_order (woocommerce_id, crm_id, sync_date) VALUES (?, ?, NOW())";
                    $dbh->run($sql, array($postData['id'], $resUpdate['id']));

                    putlogwebhook("Success, account updated.");

                } catch (Exception $e) {
                    putlogwebhook('Error while updating Account in CRM. error = ' . $e->getMessage());
                }
            } else {
                putlogwebhook("Account already haev schools in it,, not updating it. school -> " . $resultOrg[0]['cf_accounts_selectedyearlevels']);
            }
            /**/
        } else {
            putlogwebhook('No Account found for name and no new accout created = ' . $schoolName);
        }
    } catch (Exception $e) {
        putlogwebhook('Error while fetching account from CRM. error = ' . $e->getMessage());
    }
} else {
    if (empty($schoolName)) {
        putlogwebhook('No school name in order');
    }else{
        putlogwebhook('Order status is not processing');
    }
}
putlogwebhook("========== END==========");


function putlogwebhook($var)
{
    $content = date("Y-m-d H:i:s") . "\t";
    if (is_array($var) || is_object($var)) {
        $content .= print_r($var, true);
    } else {
        $content .= $var;
    }
    $content .= "\n";
    echo $content;
    echo "<br>";
    if (!file_exists(dirname(__FILE__) . "/Order.log")) {
        @touch(dirname(__FILE__) . "/Order.log", 0777, true);
    }
    file_put_contents(dirname(__FILE__) . "/Order.log", $content, FILE_APPEND);
}