<?php 
	
	chdir(dirname(__FILE__) . '/..');
	include_once 'custommods/AgileCRMAPI_Util.php';

    // create class object to Agile CRMA PI Call
	$agilecrmapiobj = new AgileCRMAPI();
    
    echo "<br> startdate = ".$startdate = date('Y-m-d',strtotime("-500 days"));
    echo "<br> enddate = ".$enddate = date('Y-m-d');
	
    $data['startdate'] = strtotime($startdate);
    $data['enddate'] = strtotime($enddate);
    $listofallevents = $agilecrmapiobj->getallEvents($data);
    
    $listofallevents = json_decode($listofallevents,true);
    echo "<br> listofallevents count = ".count($listofallevents);

    //set CSV Header
    $csvHeader = array('Id','Start','Entity Type','Type','End','Is event starred','AllDay','Title','Color','Background Color','Created Time','Description','Contacts','owner');
    $csvData = array();
    foreach ($listofallevents as $key => $allevents) {

        $description = strip_tags($allevents['description']);
        $description = preg_replace("/&#?[a-z0-9]{2,8};/i","",$description );
        $description=str_replace("\r\n","",$description);
        $description=str_replace(","," ",$description);
        $description=str_replace(";"," ",$description);
        $description = '';

        $csvData[$key] = array(
            $allevents['id'],
            date('Y-m-d H:i:s',$allevents['start']),
            $allevents['entity_type'],
            $allevents['type'],
            date('Y-m-d H:i:s',$allevents['end']),
            $allevents['is_event_starred'],
            $allevents['allDay'],
            $allevents['title'],
            $allevents['color'],
            $allevents['backgroundColor'],
            date('Y-m-d H:i:s',$allevents['created_time']),
            $allevents['description'],
        );
        $arrayContact = array();
        $arrayAccount = array();
        $contactList = '';
        $ownerData = '';
        if(count($allevents['contacts']) > 0){
            foreach ($allevents['contacts'] as $k => $contactsDetails) {
                $contactList .= "\nID = ". $contactsDetails['id']. "||Type=". $contactsDetails['type'];
                foreach ($contactsDetails['properties'] as $j => $contactsDetail) {
                    $contactList .= "||".$contactsDetail['name']."=" .str_replace([',','"','\''],"",$contactsDetail['value']);
                }
            }
            $csvData[$key][] = $contactList;
        }else{
            $csvData[$key][] = "";
        }
        if(count($allevents['owner']) > 0){
            $ownerData .= "Id = ".$allevents['owner']['id']." \n Domain = ".$allevents['owner']['domain']." \n Email = ".$allevents['owner']['email']." \n Phone = ".$allevents['owner']['phone']." \n Name = ".$allevents['owner']['name']." \n Pic = ".$allevents['owner']['pic']." \n Schedule_id = ".$allevents['owner']['schedule_id']." \n Calendar_url = ".$allevents['owner']['calendar_url']." \n CalendarURL = ".$allevents['owner']['calendarURL'];
            $csvData[$key][] = $ownerData;
        }else{
            $csvData[$key][] = "";
        }
    }
    $filename = 'logs/AgileCRM.csv';
    exportArraytoCSV($csvHeader, $csvData, $filename);
    
/*
* Funcation to export CSV file from Array
* param CSV Header, CSV Data, File name
*/
function exportArraytoCSV($csvHeader, $csvData, $filename){
    $printCSVdata = '';
    $header = implode("\", \"", $csvHeader);
    $header = "\"" .$header;
    $header .= "\"\r\n";
    $printCSVdata .= $header;

    foreach($csvData as $row) {
        foreach ($row as $key => $value) {
            /* To support double quotations in CSV format
             * To review: http://creativyst.com/Doc/Articles/CSV/CSV01.htm#EmbedBRs
             */
            $row[$key] = str_replace('"', '""', $value);
        }
        $line = implode("\",\"",$row);
        $line = "\"" .$line;
        $line .= "\"\r\n";
        $printCSVdata .= $line;
    }
    file_put_contents($filename, $printCSVdata);
}
?>
