var Events_Component_54332AddPrimaryContacts = VTAP.Component.Core.extend({
    created() {
        VTAP.Component.Register('DETAIL_BASIC_BUTTON',
            {},
            VTAP.Component.Load('AddPrimaryContactsButton','Events'));
    }
});
var Events_Component_AddPrimaryContactsButton = VTAP.Component.Core.extend({
    data() {
        return {
            showButton: false,
            showProgress: false,
        }
    },

    async mounted() {
        var recordId = VTAP.Detail.Id();
        var allOrg = await this.getAllOrg(recordId,'1');
        var allOrgRelated = await this.getAllRelatedOrg(recordId);
        if (allOrg.length  > 0 || allOrgRelated.account_id.id > 0){
            this.showButton = true;
        }
    },

    methods: {
        async addPrimaryContacts() {
            var recordId = VTAP.Detail.Id();
            var primaryContactsIds = '';

            this.showProgress = true;
            var allOrg = [];
            var page ='1';
            for (;;page++){
                let orgs = await this.getAllOrg(recordId,page);
                if(orgs.length > 0){
                    allOrg = [...allOrg,...orgs];
                }
                if(orgs.length<25){
                    break;
                }else{
                    continue;
                }
            }
            var allOrgRelated = await this.getAllRelatedOrg(recordId);
            if(allOrgRelated.account_id.id > 0){
                allOrg.push(allOrgRelated.account_id);
            }
            for (let index in allOrg) {
                var allContact = await this.getAllContact(allOrg[index].id);

                for (let indexC in allContact) {
                    if (allContact[indexC].cf_contacts_type == 'Primary'||allContact[indexC].cf_contacts_type == 'Ambassador'){
                        if (primaryContactsIds == ''){
                            primaryContactsIds = allContact[indexC].id;
                        }else{
                            primaryContactsIds = primaryContactsIds += ','+allContact[indexC].id
                        }
                    }
                }
            }

            // console.log('primaryContactsIds',primaryContactsIds)

            VTAP.Api.Put('records',{
                module:'Events',
                id:recordId,
                'contact_id':primaryContactsIds
            }, (res,err) => {
                // console.log('VTAP.Api.Put',res);
            });

            this.showProgress = false;

            VTAP.Utility.ShowSuccessNotification('Primary Contacts Added');
        },

        async getAllOrg(recordId,page){
            return new Promise(resolve => {
                VTAP.Api.Get('records/relationrecords', {
                    'module': 'Events',
                    'sortfield': 'modifiedtime',
                    'page':page,
                    'id': recordId,
                    'relationid':5590
                }, async (error, response) => {
                    resolve(response);
                });
            });
        },
        async getAllRelatedOrg(recordId){
            return new Promise(resolve => {
                VTAP.Api.Get('records', {
                    'module': 'Events',
                    'sortfield': 'modifiedtime',
                    'id': recordId,
                    'relationid':5590
                }, async (error, response) => {
                    resolve(response);
                });
            });
        },
        async getAllContact(recordId){
            return new Promise(resolve => {
                VTAP.Api.Get('records/relationrecords', {
                    'module': 'Accounts',
                    'sortfield': 'modifiedtime',
                    'id': recordId,
                    'relationid':1
                }, async (error, response) => {
                    resolve(response);
                });
            });
        },
    },
    template: `<b-button class='btn primary px-2 py-2 mr-2' v-if="showButton" @click="addPrimaryContacts" ref="btnShow" style="display: flex;">
                    Auto Add Contacts&nbsp;&nbsp;<b-spinner v-if="showProgress" label="loading" style="width: 1rem;height: 1rem;align-self: center;"></b-spinner>
               </b-button>`
});