var Events_Component_54701AddSendInvitation = VTAP.Component.Core.extend({
    created() {
        VTAP.Component.Register('DETAIL_BASIC_BUTTON',
            {},
            VTAP.Component.Load('AddSendInvitationButton', 'Events'));
    }
});
var Events_Component_AddSendInvitationButton = VTAP.Component.Core.extend({
    methods: {
        showModalPopupOrganization() {
            var recordId = VTAP.Detail.Id();
            VTAP.Utility.ShowModal({
                component: VTAP.Component.Load('PopupOrganization', 'Events'),
                componentData: {title: 'Organizations'},
                modalOnModalMode: true
            });
        },
    },
    template: `<b-button class='btn primary px-2 py-2 mr-2'  v-if="VTAP.Detail.Module() == 'Events'" @click="showModalPopupOrganization" ref="btnShow" >Send Invitations</b-button>`
});

var Events_Component_PopupOrganization = VTAP.Component.Core.extend({

    data() {
        return {
            showProgress: false,
            listOrganizations: [],
            listHistory: [],
            allEmailTemplate: [],
            allEmailTemplateList: [],
            isCheckAll: false,
            listSendMail: [],
            selecteTemplates: '',
            massupdatevalue: '',
            searchFields: [],
            statusPickList: [],
            eventstatusPickList: [],
            allRecords: [],
            getEventStatus: [],
            popupTitle: '',
        }
    },

    async mounted() {
        var recordId = VTAP.Detail.Id();
        this.showProgress = true;
        var eventObj = await this.getRecordData(recordId, 'Events');
        var getfulldate = eventObj.date_start.split('-');
        var formatedDate = getfulldate[2]+'-'+getfulldate[1]+'-'+getfulldate[0];
        this.popupTitle = "Organizations | " + eventObj.subject + " | " + formatedDate + " | " + eventObj.assigned_user_id.label
        let contactModuleObj = VTAP.Modules.GetModule('Contacts').then((moduleObject) => {
            if(moduleObject.fields.cf_contacts_confirmationstatus._picklistValues != ''){
                this.statusPickList = moduleObject.fields.cf_contacts_confirmationstatus._picklistValues;
            }
        });
        this.eventstatusPickList = ['Invited', 'Reminder sent', 'Phone reminder','Date confirmed', 'Date declined', 'New date TBC'];
        await this.getDataForModal(recordId);
        this.searchFields.eventstatus = '';
        //this.showProgress = false;
    },
    methods: {
        getRecordData : function (recordId,module) {
            return new Promise(resolve => {
                VTAP.Api.Get('records', {
                    'module': module,
                    'id': recordId
                }, (error, response) => {
                    resolve(response);
                });
            });
        },
        toggleSelect: function () {
            this.isCheckAll = !this.isCheckAll;
            if (this.isCheckAll) { // Check all
                for (var key in this.listOrganizations) {
                    this.listOrganizations[key]['checked'] = true;
                }
            } else {
                for (var key in this.listOrganizations) {
                    this.listOrganizations[key]['checked'] = false;
                }
            }
        },
        async getDataForModal() {
            var self = this;
            var recordId = VTAP.Detail.Id();
            var allOrg = await this.getAllOrg(recordId);
            var emailTemplate = await this.getEmailTemplates(0);
            var i = 0;
            for (let template in emailTemplate) {
                if (emailTemplate[template].source_module == "Contacts" || emailTemplate[template].source_module == "Events") {
                    this.allEmailTemplate[i] = emailTemplate[template];
                    this.allEmailTemplateList.push(emailTemplate[template]['templatename']);
                    i++;
                }
            }
            var emailTemplate = await this.getEmailTemplates(1);
            for (let template in emailTemplate) {
                if (emailTemplate[template].source_module == "Contacts" || emailTemplate[template].source_module == "Events") {
                    this.allEmailTemplate[i] = emailTemplate[template];
                    this.allEmailTemplateList.push(emailTemplate[template]['templatename']);
                    i++;
                }
            }
            var emailTemplate = await this.getEmailTemplates(2);
            for (let template in emailTemplate) {
                if (emailTemplate[template].source_module == "Contacts" || emailTemplate[template].source_module == "Events") {
                    this.allEmailTemplate[i] = emailTemplate[template];
                    this.allEmailTemplateList.push(emailTemplate[template]['templatename']);
                    i++;
                }
            }
            this.selecteTemplates = this.allEmailTemplate[0]['templatename'];
            var siteApiUrl = 'https://devl06.borugroup.com/resilience/';

            $.ajax({
                url: siteApiUrl + "Events/55779_getEventStatus.php",
                method: "POST",
                data: {'eventid': recordId},
                dataType: "json",
                success: async function (result) {
                    this.getEventStatus = await result.eventstatus;
                    this.geteventstatusAll = await result.eventstatusAll;
                    for (let index in allOrg) {
                        var allContact = await self.getAllContact(allOrg[index].id);
                        for (let indexC in allContact) {
                            if(typeof this.getEventStatus[allContact[indexC].id] != 'undefined'){
                                allContact[indexC]['confirmationeventstatus'] = this.getEventStatus[allContact[indexC].id];
                            }else{
                                allContact[indexC]['confirmationeventstatus'] = ' ';
                            }
                            if (allContact[indexC].cf_contacts_type === 'Primary' || allContact[indexC].cf_contacts_type === 'Ambassador') {
                                allContact[indexC]['checked'] = false;
                                self.listOrganizations.push(allContact[indexC]);
                                var HistoryVar = this.geteventstatusAll[allContact[indexC].id];
                                for( let indexn in HistoryVar){
                                    var itemlist = [];
                                    itemlist['contactid'] =  allContact[indexC].id;
                                    itemlist['conctatname'] = allContact[indexC].firstname +' '+ allContact[indexC].lastname;
                                    itemlist['conctatemil'] = allContact[indexC].email;
                                    itemlist['orgname'] = allContact[indexC].account_id.label;
                                    itemlist['datetime'] = HistoryVar[indexn].datetime;
                                    itemlist['historyStatusString'] = HistoryVar[indexn].historyStatusString;

                                    self.listHistory.push(itemlist);
                                }
                            }
                        }
                    }
                    self.showProgress = false;
                }
            });
            if(allOrg.length == 0){
                self.showProgress = false;
            }

            this.allRecords = this.listOrganizations;
            this.allHistoryRecords = this.listHistory;
            console.log('listOrganizations = ',this.listOrganizations);
            console.log('listHistory = ',this.listHistory);
        },
        async getAllOrg(recordId) {
            return new Promise(async resolve => {
                var records = [];
                var checkNext = true;
                var pageNum = 1;
                while (checkNext === true) {
                    var relData = await this.getRelatedDataNew(recordId,'Events',5590,pageNum)
                    var currentLentght = relData.length;
                    records = $.merge(relData,records);
                    if (currentLentght < 20){
                        checkNext = false;
                        resolve(records)
                    }
                    pageNum = pageNum + 1;
                }
            });
        },
        async getAllContact(recordId) {
            return new Promise(async resolve => {
                var records = [];
                var checkNext = true;
                var pageNum = 1;
                while (checkNext === true) {
                    var relData = await this.getRelatedDataNew(recordId,'Accounts',1,pageNum)
                    var currentLentght = relData.length;
                    records = $.merge(relData,records);
                    if (currentLentght < 20){
                        checkNext = false;
                        resolve(records)
                    }
                    pageNum = pageNum + 1;
                }
            });
        },
        async getRelatedDataNew(recordId,module,relationid,page=1) {
            return new Promise(resolve => {
                VTAP.Api.Get('records/relationrecords', {
                    'module': module,
                    'sortfield': 'modifiedtime',
                    'relationid': relationid,
                    'page': page,
                    'id': recordId
                }, (error, response) => {
                    resolve(response);
                });
            });
        },
        async getEmailTemplates(page) {
            return new Promise(resolve => {
                VTAP.CustomApi.Get("get_all_email_templates", {page:page}, (error, response) => {
                    if(response) {
                        resolve(response);
                    }
                });
            });
        },
        sendMail: function () {
            this.listSendMail = [];
            for (var key in this.listOrganizations) {
                if (this.listOrganizations[key]['checked'] === true) {
                    this.listSendMail.push(this.listOrganizations[key]);
                }
            }
            if (this.listSendMail.length > 0 && this.selecteTemplates !== '') {
                console.log(this.listSendMail);
                let _this = this;
                var recordId = VTAP.Detail.Id();
                _this.showProgress = true;
                var siteApiUrl = 'https://devl06.borugroup.com/resilience/';
                $.ajax({
                    url: siteApiUrl + "Events/54701_sendInvitation.php",
                    method: "POST",
                    data: {'list': this.listSendMail, 'selectedEmail': this.selecteTemplates, 'eventid': recordId},
                    dataType: "json",
                    success: function (result) {
                        _this.showProgress = false;
                        console.log('result', result);
                        if (result.success) {
                            VTAP.Utility.ShowSuccessNotification("Mail Send Successfully");
                        } else {
                            VTAP.Utility.ShowErrorNotification("Error")
                        }
                    }
                });
            }

        },
        updateMassEventStatus: function () {
            let contactlist = [];
            for (var key in this.listOrganizations) {
                if (this.listOrganizations[key]['checked'] === true) {
                    console.log('this.listOrganizations[key] = ',this.listOrganizations[key]['id']);
                    contactlist.push(this.listOrganizations[key]['id']);
                }
            }
            if(contactlist.length == 0) {
                VTAP.Utility.ShowErrorNotification('Please select Contacts.');
                this.massupdatevalue = '';
            }else{
                var selectedStatus = event.target.value;
                this.massupdatevalue = selectedStatus;
                let _this = this;
                var recordId = VTAP.Detail.Id();
                var result = confirm("Are you sure you want update selected records?");
                if (result && selectedStatus != '') {
                    _this.showProgress = true;
                    var siteApiUrl = 'https://devl06.borugroup.com/resilience/';
                    $.ajax({
                        url: siteApiUrl + "Events/55779_updateEventStatus.php",
                        method: "POST",
                        data: {'contactid': contactlist, 'eventid': recordId, 'selectedStatus':selectedStatus},
                        dataType: "json",
                        success: function (result) {
                            _this.showProgress = false;
                            if (result.success) {
                                for (var key in _this.listOrganizations) {
                                    if (_this.listOrganizations[key]['checked'] === true) {
                                        _this.listOrganizations[key]['confirmationeventstatus'] = selectedStatus ;
                                    }
                                }
                                VTAP.Utility.ShowSuccessNotification("Status updated Successfully");
                                _this.massupdatevalue = '';
                            } else {
                                VTAP.Utility.ShowErrorNotification("Error while updating Status")
                                _this.massupdatevalue = '';
                            }
                        }
                    });
                }else{
                    this.massupdatevalue = '';
                }
            }

        },
        popupEditTemplate: function () {
            let selecteTemplatesID ="";
            for (let template in this.allEmailTemplate){
                if(this.allEmailTemplate[template]['templatename'] == this.selecteTemplates){
                    selecteTemplatesID = this.allEmailTemplate[template]['id'];
                }
            }

            let contactlist = [];
            for (var key in this.listOrganizations) {
                if (this.listOrganizations[key]['checked'] === true) {
                    contactlist.push(this.listOrganizations[key]);
                }
            }
            if(selecteTemplatesID != '' && contactlist.length > 0){
                selecteTemplatesID = selecteTemplatesID.split('x')[1];
                VTAP.Utility.ShowModal({
                    component: VTAP.Component.Load('EditPopupTemplate', 'Events'),
                    componentData: {selectedTemplateId:selecteTemplatesID,title: 'Edit Template',contactlist:contactlist},
                    modalOnModalMode: true
                });
            }else{
                if(contactlist.length == 0){
                    VTAP.Utility.ShowErrorNotification('Please select Contacts.');
                }else{
                    VTAP.Utility.ShowErrorNotification('Please select Email Template.');
                }
            }
        },
        redirectTemplate: function () {
            let selecteTemplatesID ="";
            for (let template in this.allEmailTemplate){
                if(this.allEmailTemplate[template]['templatename'] == this.selecteTemplates){
                    selecteTemplatesID = this.allEmailTemplate[template]['id'];
                }
            }
            if(selecteTemplatesID != ''){
                window.open('https://theresilienceproject.od2.vtiger.com/view/detail?module=EmailTemplates&id='+selecteTemplatesID+ '&relatedtab=Details&relationid=__details__', "_blank");
            }
        },
        updateEventstatus: function (event) {
            var contactid = event.target.getAttribute('data-contact-id');
            var selectedStatus = event.target.value;
            let _this = this;
            var recordId = VTAP.Detail.Id();
            _this.showProgress = true;
            var siteApiUrl = 'https://devl06.borugroup.com/resilience/';
            $.ajax({
                url: siteApiUrl + "Events/55779_updateEventStatus.php",
                method: "POST",
                data: {'contactid': contactid, 'eventid': recordId, 'selectedStatus':selectedStatus},
                dataType: "json",
                success: function (result) {
                    _this.showProgress = false;
                    if (result.success) {
                        VTAP.Utility.ShowSuccessNotification("Status updated Successfully");
                    } else {
                        VTAP.Utility.ShowErrorNotification("Error while updating Status")
                    }
                }
            });
        },
        async showCurrentViewTab() {
            $('#history_tab').removeClass('active');
            $('.float-right').css('display', 'block');
            $('#current_tab').addClass('active');
            $('#current_content').css('display', 'block');
            $('#history_content').css('display', 'none');
        },
        async showHistoryTab() {
            $('.float-right').css('display', 'none');
            $('#current_tab').removeClass('active');
            $('#history_tab').addClass('active');
            $('#history_content').css('display', 'block');
            $('#current_content').css('display', 'none');
        },
        searchhistoryColumns: function (e) {
            this.listHistory = [];
            let emptySearchField = false;
            let listSearchVal = [];
            this.listHistory = this.allHistoryRecords.filter(post => {
                let check = true;
                if (typeof this.searchFields.contactsName != 'undefined' && this.searchFields.contactsName != '' && check == true) {
                    check = post.conctatname.toLowerCase().includes(this.searchFields.contactsName.toLowerCase());
                }
                if (typeof this.searchFields.email != 'undefined' && this.searchFields.email != '' && check == true) {
                    check = post.conctatemil.toLowerCase().includes(this.searchFields.email.toLowerCase());
                }
                if (typeof this.searchFields.orgName != 'undefined' && this.searchFields.orgName != '' && check == true) {
                    check = post.orgname.toLowerCase().includes(this.searchFields.orgName.toLowerCase());
                }
                if (typeof this.searchFields.historyStatusString != 'undefined' && this.searchFields.historyStatusString != '' && check == true) {
                    check = post.historyStatusString.toLowerCase().includes(this.searchFields.historyStatusString.toLowerCase());
                }
                return check === true ? post : false;
            });
        },
        searchColumns: function (e) {
            this.listOrganizations = [];
            let emptySearchField = false;
            let listSearchVal = [];
            this.listOrganizations = this.allRecords.filter(post => {
                let check = true;
                if (typeof this.searchFields.contactsName != 'undefined' && this.searchFields.contactsName != '' && check == true) {
                    check = post.firstname.toLowerCase().includes(this.searchFields.contactsName.toLowerCase());
                }
                if (typeof this.searchFields.email != 'undefined' && this.searchFields.email != '' && check == true) {
                    check = post.email.toLowerCase().includes(this.searchFields.email.toLowerCase());
                }
                if (typeof this.searchFields.orgName != 'undefined' && this.searchFields.orgName != '' && check == true) {
                    check = post.account_id.label.toLowerCase().includes(this.searchFields.orgName.toLowerCase());
                }
                if (typeof this.searchFields.status != 'undefined' && this.searchFields.status != '' && check == true) {
                    check = post.cf_contacts_confirmationstatus.toLowerCase().includes(this.searchFields.status.toLowerCase());
                }
                if (typeof this.searchFields.cf_contacts_type != 'undefined' && this.searchFields.cf_contacts_type != '' && check == true) {
                    check = post.cf_contacts_type.toLowerCase().includes(this.searchFields.cf_contacts_type.toLowerCase());
                }
                if (typeof this.searchFields.eventstatus != 'undefined' && this.searchFields.eventstatus != '' && check == true) {
                    check = post.confirmationeventstatus.toLowerCase().includes(this.searchFields.eventstatus.toLowerCase());
                }
                return check === true ? post : false;
            });
        }
    },


    template: `<b-modal size="xxl" id="btn-events-createClinsQuote" :title="popupTitle" ref= "PopupOrganization" hide-footer="false">
            <div class='py-1' v-if="showProgress" style="opacity: 0.5; background-color: #ccc; z-index: 100000; position: fixed; top: 0px; width: 100%; height: 100%;margin-left: -40px;">
                <div class='d-flex justify-content-center align-items-center' style="top: 40vh; position: relative">
                    <b-spinner label="loading"></b-spinner>
                </div>
            </div>
            <div class="py-1 invitationpopup">
                <ul class="nav nav-tabs">
                    <li class="nav-tab active" data-tab="current_tab" id="current_tab">
                        <a @click="showCurrentViewTab"><strong>Current Status</strong></a>
                    </li>
                    <li class="nav-tab" data-tab="history_tab" id="history_tab">
                        <a @click="showHistoryTab"><strong>Status History</strong></a>
                    </li>
                </ul>
                <div class="tab-content">
                <div class="tab-pane active" id="current_content" data-content="current_tab">
                    <table class="table mb-0">
                        <tr class="lineItemTableRow">
                            <th width=0.1%>
                            <input type="checkbox"  @click="toggleSelect" v-model='isCheckAll'>
                            </th>
                            <th width="10%"><div class="label"><label title="CONTACT NAME" name="contactName">CONTACT NAME</label></div></th> 
                            <th width="10%"><div class="label"><label title="EMAIL" name="email">EMAIL ADDRESS</label></div></th> 
                            <th width="10%"><div class="label"><label title="ORGANIZATION NAME" name="organizationName">ORGANIZATION NAME</label></div></th>
                            <th width="10%"><div class="label"><label title="TYPE" name="type">TYPE</label></div></th>
                            <!--<th width="10%"><div class="label"><label title="STATUS" name="status">STATUS</label></div></th>-->
                            <th width="10%"><div class="label"><label title="CONFIRMATION EVENT STATUS" name="status">EVENT STATUS</label>
                            <select class="form-control" v-model="massupdatevalue" @change="updateMassEventStatus(event)"><option value="">Select an Option</option><option v-for="value, keyIndex in eventstatusPickList" :value="value" >{{value}}</option></select></div></th>
                        </tr>
                        <!--Searching Columns-->
                        <tr class="lineItemTableRow">
                            <th width=0.1%></th>
                            <th scope="col" ><input type="text" :value="searchFields.contactsName" placeholder="Search" class="form-control d-inline-block rounded" name="search" @keyup="searchColumns(event)" v-model="searchFields.contactsName"></th>
                            <th scope="col" ><input type="text" :value="searchFields.email" placeholder="Search" class="form-control d-inline-block rounded" name="search" @keyup="searchColumns(event)" v-model="searchFields.email"></th>
                            <th scope="col" ><input type="text" :value="searchFields.orgName" placeholder="Search" class="form-control d-inline-block rounded" name="search" @keyup="searchColumns(event)" v-model="searchFields.orgName"></th>
                            <th scope="col" ><input type="text" :value="searchFields.cf_contacts_type" placeholder="Search" class="form-control d-inline-block rounded" name="cf_contacts_type" @keyup="searchColumns(event)" v-model="searchFields.cf_contacts_type"></th>
                            <!--<th scope="col" ><select class="form-control" v-model="searchFields.status" @change="searchColumns(event)"><option value=""></option><option v-for="picklist, keyIndex in statusPickList" :value="picklist.value" >{{picklist.value}}</option></select></th>-->
                            <th scope="col" > <select class="form-control" v-model="searchFields.eventstatus" @change="searchColumns(event)"><option value="">Show All</option><option v-for="value, keyIndex in eventstatusPickList" :value="value" >{{value}}</option></select></th>
                        </tr>
                        <tbody v-if="listOrganizations.length > 0">
                        <tr  v-for="orgData, keyIndex in listOrganizations">
                            <td class="lineItemCustomFields">  <input type="checkbox" v-model="orgData.checked" :value="orgData.checked"></td>
                            <td class="lineItemCustomFields" :data-contact-id="orgData.id">{{orgData.firstname}}&nbsp;{{orgData.lastname}}</td>
                            <td class="lineItemCustomFields">{{orgData.email}}</td>
                            <td class="lineItemCustomFields" :data-org-id='orgData.account_id.id'>{{orgData.account_id.label}}</td>
                            <td class="lineItemCustomFields">{{orgData.cf_contacts_type}}</td>
                            <!--<td class="lineItemCustomFields">{{orgData.cf_contacts_confirmationstatus}}</td>-->
                            <td class="lineItemCustomFields" :data-contact-id="orgData.id"> <select :data-contact-id="orgData.id" class="form-control" v-model="orgData.confirmationeventstatus" @change="updateEventstatus(event)"><option value=''></option><option v-for="value, keyIndex in eventstatusPickList" :value="value" >{{value}}</option></select> </td>
                        </tr>
                        </tbody>
                        <tbody v-else>
                            <tr><td></td><td colspan="6">No Records Found</td></tr>
                        </tbody>
                    </table>
                </div>
                <div class="tab-pane" id="history_content" data-content="history_tab" style="display:none;">
                <div class="row">
                    <div class="col-md-12">
                        <table class="table mb-0">
                        <tr class="lineItemTableRow">
                            <th width="10%"><div class="label"><label title="CONTACT NAME" name="contactName">CONTACT NAME</label></div></th> 
                            <th width="10%"><div class="label"><label title="EMAIL" name="email">EMAIL ADDRESS</label></div></th> 
                            <th width="10%"><div class="label"><label title="ORGANIZATION NAME" name="organizationName">ORGANIZATION NAME</label></div></th>
                            <th width="50%"><div class="label"><label title="CONFIRMATION EVENT STATUS" name="status">Updates</label></div></th>
                        </tr>
                        <!--Searching Columns-->
                        <tr class="lineItemTableRow">
                            <th scope="col" ><input type="text" :value="searchFields.contactsName" placeholder="Search" class="form-control d-inline-block rounded" name="search" @keyup="searchhistoryColumns(event)" v-model="searchFields.contactsName"></th>
                            <th scope="col" ><input type="text" :value="searchFields.email" placeholder="Search" class="form-control d-inline-block rounded" name="search" @keyup="searchhistoryColumns(event)" v-model="searchFields.email"></th>
                            <th scope="col" ><input type="text" :value="searchFields.orgName" placeholder="Search" class="form-control d-inline-block rounded" name="search" @keyup="searchhistoryColumns(event)" v-model="searchFields.orgName"></th>
                            <th scope="col" ><input type="text" :value="searchFields.historyStatusString" placeholder="Search" class="form-control d-inline-block rounded" name="search" @keyup="searchhistoryColumns(event)" v-model="searchFields.historyStatusString"></th>
                        </tr>
                        <tbody v-if="listHistory.length > 0">
                        <tr  v-for="historyData, keyIndex in listHistory">
                            <td class="lineItemCustomFields" >{{historyData.conctatname}}</td>
                            <td class="lineItemCustomFields">{{historyData.conctatemil}}</td>
                            <td class="lineItemCustomFields" >{{historyData.orgname}}</td>
                            <td class="lineItemCustomFields" v-html="historyData.historyStatusString"></td>
                        </tr>
                        </tbody>
                        <tbody v-else>
                            <tr><td></td><td colspan="6">No Records Found</td></tr>
                        </tbody>
                    </table>
                    </div>
                </div>
                </div>
                <div class="float-right" style="max-width:52%">
                    Select Email templates: 
                    <v-select2 v-model="selecteTemplates"  :options="allEmailTemplateList" :emptyOption=false style="width: 350px"></v-select2>
                    <button title="Edit Email Template" @click="popupEditTemplate()" class="btn btn-secondary px-2-5 shadow-none height-36px"><i class="fa-pencil baseFontColor align-middle"></i></button>
                    <button class='btn btn-primary'  @click="sendMail" >Send Mail</button>
                </div>
            </div>
          </b-modal>`
});

var Events_Component_EditPopupTemplate = VTAP.Component.Core.extend({

    data() {
        return {
            showProgress: false,
            subject: '',
            body: '',
            selectedMergetag: '',
            mergeTagList: [],
            contactlist: [],
            selectedTemplateId: [],
            label: '',
        }
    },

    async mounted() {
        var recordId = VTAP.Detail.Id();
        this.selectedTemplateId = this['$attrs']['selectedTemplateId'];
        this.contactlist = this['$attrs']['contactlist'];
        this.showProgress = true;
        var templateDetail = await this.getEmailTemplateDetails(this.selectedTemplateId);

        this.subject = templateDetail['subject'];
        this.body = templateDetail['body'];
        this.label = templateDetail['label'];
        this.showProgress = false;

        CKEDITOR.editorConfig = function (config) {
            config.language = 'es';
            config.uiColor = '#F7B42C';
            config.height = 300;
            config.toolbarCanCollapse = true;

        };
        CKEDITOR.replace('description');

        VTAP.Modules.GetModule('Contacts').then( (moduleObject) => {
            var moduleObjectfields = moduleObject.fields;
            for (let index in moduleObjectfields) {
                if(moduleObjectfields[index].type.name != 'owner' && moduleObjectfields[index].type.name != 'reference' && moduleObjectfields[index].viewable == true && moduleObjectfields[index].presence == "0"){
                    this.mergeTagList.push({"fieldlabel": moduleObjectfields[index].fieldlabel, "fieldname": moduleObjectfields[index].fieldname});
                }
            }
        });

    },
    methods: {
        getEmailTemplateDetails: function (templateId) {
            return new Promise(resolve => {
                VTAP.Api.Get('records', {
                    'module': 'EmailTemplates',
                    'id': templateId,
                }, async (error, response) => {
                    resolve(response);
                });
            });
        },
        sendEditMail: function () {
            this.body =  CKEDITOR.instances.description.getData();
            if (this.contactlist.length > 0 && this.label !== '') {
                console.log(this.contactlist);
                let _this = this;
                var recordId = VTAP.Detail.Id();
                _this.showProgress = true;
                var siteApiUrl = 'https://devl06.borugroup.com/resilience/';
                $.ajax({
                    url: siteApiUrl + "Events/54701_sendInvitation.php",
                    method: "POST",
                    data: {'list': this.contactlist, 'selectedEmail': this.label, 'mailSubject':this.subject, 'mailBody':this.body, 'eventid': recordId},
                    dataType: "json",
                    success: function (result) {
                        _this.showProgress = false;
                        console.log('result', result);
                        if (result.success) {
                            VTAP.Utility.ShowSuccessNotification("Mail Send Successfully");
                        } else {
                            VTAP.Utility.ShowErrorNotification("Error")

                        }
                    }
                });
            }

        },
        selectMergeTag: async function (event) {
            var textarea = CKEDITOR.instances.description;
            var value = "$contacts-"+this.selectedMergetag+"$";
            if (textarea != undefined) {
                textarea.insertHtml(value);
            }
        },
    },


    template: `<b-modal size="xl" id="btn-events-createClinsQuote" title="Edit Template" ref= "EditPopupTemplate" hide-footer="false">
            <div class="py-1">
                <div class='py-1' v-if="showProgress">
                    <div class='d-flex justify-content-center align-items-center'>
                        <b-spinner label="loading"></b-spinner>
                    </div>
                </div>
                <div  class="EditTemplateContainer">
                    <div class="d-flex mb-2">
                        <label class="d-flex align-items-center col-1 pl-0  mb-0 justify-content-end">Subject<span class="text-danger">*</span></label>
                        <div class="w-100">
                            <input type="text" v-model="subject" name="subject" placeholder="Subject" class="form-control height-40px border-grey-2" aria-required="true" aria-invalid="true">
                        </div>
                    </div>
                    <div class="d-flex mb-2">
                        <label class="d-flex align-items-center col-1 pl-0  mb-0 justify-content-end">Merge Tag</label>
                        <div class="w-100">
                            <select class="form-control" v-model="selectedMergetag" @change="selectMergeTag($event)">
                                <option value="">Select an Option</option>
                                <option v-for="fieldDetail, keyIndex in mergeTagList" :value="fieldDetail.fieldname">
                                    {{fieldDetail.fieldlabel}}
                                </option>
                            </select>
                        </div>
                    </div>
                    <div class="d-flex mb-2">
                        <label class="d-flex align-items-center col-1 pl-0  mb-0 justify-content-end" style="align-self: flex-start;">Body<span class="text-danger">*</span></label>
                        <div class="w-100">
                            <div class ="ckeditor">
                                <textarea v-model="body" name="description" id="description"></textarea>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="float-right" style="max-width:52%">
                    <button class='btn btn-primary'  @click="sendEditMail" >Send Mail</button>
                </div>
            </div>
          </b-modal>`
});