<?php
/**
 * TaskId: 54333
 * User: rprajapati
 * Date: 30/8/22
 * Time: 12:20 PM
 */

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: PUT, GET, POST");
header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept");

if (empty($_REQUEST['record'])) {
    $error = 'No Contact Record Provided.';
} else {
    chdir(dirname(__FILE__));
    require "../VT9_API/init_vt9.php";
    require "../init.php";

    $vtod = init_vtod();

    $allEvents = [];

    try {
        $contactId = '4x' . $_REQUEST['record'];
        $eventId = '18x'.$_REQUEST['eventid'];
        $contactRecord = $vtod->retrieve($contactId);

        if (!empty($contactRecord['id'])) {
            $vt9 = init_vt9();
            $eventRecords = $vt9->getData('GetContactEvents', array("contact_id" => $contactId, "eventstatus" => "Planned", 'after' => date('Y-m-d')));

            if ($eventRecords['result'] == true && count($eventRecords['result']) > 0) {
                $allEvents = $eventRecords['result'];
                $orderedEvents = [];

                foreach ($allEvents as $temp){
                    $dateTImetmp = convertTOSydney($temp['date_start'] . ' ' . $temp['time_start']);
                    $orderredEvents[strtotime($dateTImetmp)] = $temp;
                }
                ksort($orderredEvents);

                $eventsHtml = '<ul>';
                foreach ($orderredEvents as $key => $event) {
                    if($_REQUEST['eventid'] > 0){
                        if($event['id'] == $eventId){
                            $dateTIme = formatedatetime($event['date_start'] . ' ' . $event['time_start']) . " (AEST)";
                            $eventsHtml .= '<li><b>' . $event['cf_events_presentationworkshoptype'] . '</b> (' . $event['activitytype'] . ')<br>';
                            $eventsHtml .= $dateTIme . '</li>';
                        }
                    }else{
                        $dateTIme = formatedatetime($event['date_start'] . ' ' . $event['time_start']) . " (AEST)";

                        $eventsHtml .= '<li><b>' . $event['cf_events_presentationworkshoptype'] . '</b> (' . $event['activitytype'] . ')<br>';
                        $eventsHtml .= $dateTIme . '</li>';
                    }
                }
                $eventsHtml .= "</ul>";

            } else {
                $error = 'No Planned Events For Contact: ' . $contactRecord['firstname'] . ' ' . $contactRecord['lastname'];
            }
        } else {
            $error = 'Contact Does Not Exist In CRM.';
        }
    } catch (Exception $e) {
        $error = 'Contact Does Not Exist In CRM.';
    }
}
?>
<div class="container-fluid align-center body theme2" id="plannedEventList">
    <?php if (!empty($error)) { ?>
        <h3><?php echo $error; ?></h3>
        <?php
    } else {
        echo "<div id='event_html'>" . $eventsHtml . "</div>";
    }
    ?>
</div>
